function Create(self)


	self.laserTimer = Timer();
	self.particleTable = {};

	self.projectileVel = 30;
	self.maxTrajectoryPars = 60;


	self.mapwrapx = SceneMan.SceneWrapsX;

	for i = 1, MovableMan:GetMOIDCount()-1 do
		local gun = MovableMan:GetMOFromID(i);
		if gun.PresetName == "Aim Calculator" and SceneMan:ShortestDistance(self.Pos,ToHDFirearm(gun).MuzzlePos,self.mapwrapx).Magnitude < 5 then
			actor = MovableMan:GetMOFromID(gun.RootID);
			if gun.Sharpness == 0 and MovableMan:IsActor(actor) then
				self.parent = ToAHuman(actor);
				gun.Sharpness = 1;
			else
				self.parentgun.Sharpness = 0;
				self.ToDelete = true;
			end
			break;
		end
	end

end

function Update(self)

	if MovableMan:IsActor(self.parent) and self.parent:HasObject("Aim Calculator") then
		self.PinStrength = 1000;
		self.ToDelete = false;

		if self.laserTimer:IsPastSimMS(25) then
			self.laserTimer:Reset();

			for i = 1, #self.particleTable do
				if MovableMan:IsParticle(self.particleTable[i]) then
					self.particleTable[i].ToDelete = true;
				end
			end
			self.particleTable = {};

			if self.parent:GetController():IsState(Controller.AIM_SHARP) then
				local gun = self.parent.EquippedItem;
				if gun ~= nil then

					if gun.PresetName == "Aim Calculator" and gun.Sharpness == 0 then
						self.ToDelete = true;
					end

					local gunMag = ToHDFirearm(gun).Magazine;
					if gunMag ~= nil and gunMag.RoundCount > 0 then
						local projectileVel = gunMag.NextRound.FireVel;
						self.guideParPos = ToHDFirearm(gun).MuzzlePos;
						self.guideParVel = Vector(projectileVel,0):RadRotate(ToAHuman(actor):GetAimAngle(true));
						for i = 1, self.maxTrajectoryPars do
							if SceneMan:GetTerrMatter(self.guideParPos.X,self.guideParPos.Y) == 0 then
								self.guideParVel = self.guideParVel + Vector((SceneMan.GlobalAcc.X/FrameMan.PPM),(SceneMan.GlobalAcc.Y/FrameMan.PPM));
								self.guideParPos = self.guideParPos + self.guideParVel;
								local laserParticle = CreateMOSParticle("Dovuken Trajectory Guide Particle");
								laserParticle.Pos = self.guideParPos;
								MovableMan:AddParticle(laserParticle);
								self.particleTable[#self.particleTable+1] = laserParticle;
							else
								break;
							end
						end
					end

				end

			end
		end

	else
		self.ToDelete = true;
	end


end

function Destroy(self)

	for i = 1, #self.particleTable do
		if MovableMan:IsParticle(self.particleTable[i]) then
					self.particleTable[i].ToDelete = true;
		end
	end
	self.particleTable = {};

end