function Create(self)

	self.growthTimer = Timer();
	self.directionlistX = {0,0,1,-1};
	self.directionlistY = {1,-1,0,0};
	self.directionHold = {};

	self.growthsPerSecond = 300;

	self.vineTable = {};

	for i = 1, 5 do
		self.vineTable[#self.vineTable+1] = Vector(self.Pos.X,self.Pos.Y);
	end

end

function Update(self)

	self.PinStrength = 1000;
	self.ToDelete = false;
	self.ToSettle = false;

	if self.growthTimer.ElapsedSimTimeMS > 0 then
		local growthAmount = math.ceil(self.growthsPerSecond*(self.growthTimer.ElapsedSimTimeMS/1000));
		self.growthTimer:Reset();

		for c = 1, #self.vineTable do

			for i = 1, growthAmount do

				if self.moveToPosition == nil then
					for x = 1, 4 do
						for y = 1, 4 do
							local poX = self.vineTable[c].X+self.directionlistX[x];
							local poY = self.vineTable[c].Y+self.directionlistY[y];
							if self.mapwrapx then
								if poX > SceneMan.SceneWidth then
									poX = 0;
								elseif poX < 0 then
									poX = SceneMan.SceneWidth;
								end
							end
							if poY > SceneMan.SceneHeight or poY < 0 then
								poY = self.vineTable[c];
							end
							if SceneMan:GetTerrMatter(poX,poY) == 0 then
								self.directionHold[#self.directionHold+1] = Vector(poX,poY);
							end
						end
					end
					if #self.directionHold == 0 then
						for x = 1, 4 do
							for y = 1, 4 do
								local poX = self.vineTable[c].X+self.directionlistX[x];
								local poY = self.vineTable[c].Y+self.directionlistY[y];
								if self.mapwrapx then
									if poX > SceneMan.SceneWidth then
										poX = 0;
									elseif poX < 0 then
										poX = SceneMan.SceneWidth;
									end
								end
								if poY > SceneMan.SceneHeight or poY < 0 then
									poY = self.vineTable[c];
								end
								if SceneMan:GetTerrMatter(poX,poY) == 5 then
									self.directionHold[#self.directionHold+1] = Vector(poX,poY);
								end
							end
						end
					end
				end

				if #self.directionHold > 0 then
					self.vineTable[c] = self.directionHold[math.random(1,#self.directionHold)];

					local terrpar = CreateMOPixel("Particle Anti Creeper Vines Terrain "..math.random(1,2));
					terrpar.Pos = self.vineTable[c];
					MovableMan:AddParticle(terrpar);
					terrpar.ToSettle = true;
					if self.Sharpness > 0 then
						self.Sharpness = self.Sharpness - 1;
					end

				end
				self.moveToPosition = nil;
				self.directionHold = {};
			end

			if self.Sharpness == 0 then
				self.anticreep = CreateMOPixel("Particle Anti Creeper");
				self.anticreep.Pos = self.Pos;
				MovableMan:AddParticle(self.anticreep);
				self.ToDelete = true;
			end
		end -- end of     for c = 1, #self.vineTable do
	end

end

function Destroy(self)

	for particle in MovableMan.Particles do
		if particle.ClassName == "MOPixel" and (particle.PresetName == "Particle Creeper Vines Heart" or particle.PresetName == "Particle Creeper Vines Heart S" or particle.PresetName == "Particle Creeper Vines Heart SX" or particle.PresetName == "Particle Creeper Vines Heart A" or particle.PresetName == "Particle Creeper Vines Heart AX" or particle.PresetName == "Particle Creeper Vines Heart X") then
			if SceneMan:ShortestDistance(self.Pos,particle.Pos,SceneMan.SceneWrapsX).Magnitude < 500 then
				particle.Sharpness = -1;
				particle.ToDelete = true;
			end
		end
	end

	for particle in MovableMan.Particles do
		if particle.ClassName == "MOPixel" and (particle.PresetName == "Particle Creeper Vines Growth" or particle.PresetName == "Particle Creeper Vines Growth S" or particle.PresetName == "Particle Creeper Vines Growth SX" or particle.PresetName == "Particle Creeper Vines Growth A" or particle.PresetName == "Particle Creeper Vines Growth AX" or particle.PresetName == "Particle Creeper Vines Growth X" or particle.PresetName == "Particle Blue Creeper Vines Growth" or particle.PresetName == "Particle Red Creeper Vines Growth") then
			if SceneMan:ShortestDistance(self.Pos,particle.Pos,SceneMan.SceneWrapsX).Magnitude < 500 then
				particle.Sharpness = 1;
				particle.ToDelete = true;
			end
		end
	end

	for particle in MovableMan.Particles do
		if particle.PresetName == "Creeper Vines Thorn" then
			if SceneMan:ShortestDistance(self.Pos,particle.Pos,SceneMan.SceneWrapsX).Magnitude < 500 then
				particle.Sharpness = 2;
				particle.ToDelete = true;
			end
		end
	end

end