function Create(self)

	self.mapwrapx = SceneMan.SceneWrapsX;
	self.modeTimer = Timer();
	self.movementTimer = Timer();
	self.actionMode = 0; -- 0 is nothing, 1 is normal throw, 2 is draw mode, 3 is path throw, 4 is returning
	self.attackMode = 0; -- 0 is nothing, 1 is particle, 2 is gravity
	self.pathTable = {};
	self.pathSpot = 1;
	self.travelTable = {};
	self.guideTable = {};
	self.saveSharp = 0;
----------------------------------------
----- Settings

	self.flightSpeed = 450; -- Pixels per second
	self.flightTime = 1500; -- MS

	-- Flight distance = flightSpeed * flightTime

	self.spinSpeed = 50;-- radians per second

	self.drawAmount = 67; -- Max number of draw dots
	self.drawSpacing = 10; -- Space in between draw dots

	-- Draw length = drawAmount * drawSpacing

----------------------------------------

	self.catchDistance = 25;
	self.flipNum = -1;

	for i = 1,MovableMan:GetMOIDCount()-1 do
		local gun = MovableMan:GetMOFromID(i);
		if gun.PresetName == "Dov Boomerang" and SceneMan:ShortestDistance(self.Pos,ToHDFirearm(gun).MuzzlePos,self.mapwrapx).Magnitude < 10 then
			self.parentgun = ToHDFirearm(gun);
			local actor = MovableMan:GetMOFromID(self.parentgun.RootID);
			if MovableMan:IsActor(actor) then
				self.parent = ToAHuman(actor);
				self.saveSharp = self.parentgun.Sharpness;
			else
				self.ToDelete = true;
			end
			self.catchDistance = SceneMan:ShortestDistance(self.Pos,self.parent.Pos,self.mapwrapx).Magnitude;
			if self.parent.HFlipped then
				self.flipNum = 1;
				self.HFlipped = true;
			end
			self.Scale = 1;
			if self.parentgun.Sharpness ~= 0 and self.parent:IsPlayerControlled() then
				self.waitTimer = Timer();
				self.Scale = 0;
				self.actionMode = 2;
				self.pathTable[1] = Vector(self.Pos.X,self.Pos.Y);
				self.cursor = CreateActor("Dovuken Cursor");
				self.cursor.Pos = self.Pos;
				self.cursor.Team = self.parent.Team;
				MovableMan:AddActor(self.cursor);
				self.parentplayer = self.parent:GetController().Player;
				ActivityMan:GetActivity():SwitchToActor(self.cursor,self.parent:GetController().Player,self.parent.Team);
				self.parent:SetControllerMode(Controller.CIM_DISABLED, -1);
				local guidePar = CreateMOSParticle("Dovuken Trajectory Guide Particle");
				guidePar.Pos = self.pathTable[#self.pathTable];
				MovableMan:AddParticle(guidePar);
				self.guideTable[#self.guideTable+1] = guidePar;
			else
				self.actionMode = 1;
				local sfx = CreateAEmitter("Dov Boomerang Sound Throw");
				sfx.Pos = self.Pos;
				MovableMan:AddParticle(sfx)
				self.parentgun.ToDelete = true;
			end
			if self.parentgun.Sharpness == 1 then
				self.attackMode = 1;
			elseif self.parentgun.Sharpness == 2 then
				self.attackMode = 2;
			end
			break;
		end
	end

end

function Update(self)

	self.PinStrength = 1000;
	self.AngularVel = 0;
	self.ToDelete = false;
	self.ToSettle = false;

	local lastPos = Vector(self.Pos.X,self.Pos.Y);
	local moveAmount = 0;
	local spinAmount = 0;
	if self.movementTimer:IsPastSimMS(0) then
		local timePercent = self.movementTimer.ElapsedSimTimeMS/1000;
		moveAmount = self.flightSpeed*timePercent;
		spinAmount = self.spinSpeed*timePercent;
		self.movementTimer:Reset();
	end

	if MovableMan:IsActor(self.parent) then
		if self.actionMode == 1 then
			local distance = SceneMan:ShortestDistance(self.parent.Pos,self.Pos,self.mapwrapx);
			local goalPos = self.parent.Pos + Vector(distance.Magnitude+100,0):RadRotate(self.parent:GetAimAngle(true));
			local checkPos = self.Pos + Vector(moveAmount,0):RadRotate(SceneMan:ShortestDistance(self.Pos,goalPos,self.mapwrapx).AbsRadAngle);
			if SceneMan.SceneWrapsX == true then
				if checkPos.X > SceneMan.SceneWidth then
					checkPos = Vector(checkPos.X - SceneMan.SceneWidth,checkPos.Y);
				elseif checkPos.X < 0 then
					checkPos = Vector(SceneMan.SceneWidth + checkPos.X,checkPos.Y);
				end
			end
			self.Pos = checkPos;
			self.RotAngle = self.RotAngle + (spinAmount*self.flipNum);
			if self.modeTimer:IsPastSimMS(self.flightTime) or (not self.parent:GetController():IsState(Controller.WEAPON_FIRE) and self.parent:IsPlayerControlled()) then
				self.actionMode = 4;
			end
		elseif self.actionMode == 2 then
			if self.parentgun.ID == 255 then
				self.ToDelete = true;
			end
			if MovableMan:IsActor(self.cursor) and self.cursor:IsPlayerControlled() then
				if #self.pathTable < self.drawAmount then
					local distance = SceneMan:ShortestDistance(self.pathTable[#self.pathTable],self.cursor.Pos,self.mapwrapx);
					while distance.Magnitude > self.drawSpacing do
						if #self.pathTable < self.drawAmount then
							local prevSize = #self.pathTable;
							self.pathTable[#self.pathTable+1] = self.pathTable[prevSize] + distance:SetMagnitude(self.drawSpacing);
							distance = SceneMan:ShortestDistance(self.pathTable[#self.pathTable],self.cursor.Pos,self.mapwrapx);
							local guidePar = CreateMOSParticle("Dovuken Trajectory Guide Particle");
							guidePar.Pos = self.pathTable[#self.pathTable];
							MovableMan:AddParticle(guidePar);
							self.guideTable[#self.guideTable+1] = guidePar;
						else
							break;
						end
					end
				else
					self.cursor.Pos = Vector(self.pathTable[#self.pathTable].X,self.pathTable[#self.pathTable].Y);
				end
				if not self.cursor:GetController():IsState(Controller.WEAPON_FIRE) and self.waitTimer:IsPastSimMS(500) then
					if #self.pathTable < self.drawAmount then
						local distance = SceneMan:ShortestDistance(self.pathTable[#self.pathTable],self.cursor.Pos,self.mapwrapx);
						local prevSize = #self.pathTable;
						self.pathTable[#self.pathTable+1] = self.pathTable[prevSize] + distance:SetMagnitude(math.min(self.drawSpacing,moveAmount));
						local guidePar = CreateMOSParticle("Dovuken Trajectory Guide Particle");
						guidePar.Pos = self.pathTable[#self.pathTable];
						MovableMan:AddParticle(guidePar);
						self.guideTable[#self.guideTable+1] = guidePar;
					end
					self.Pos = self.parentgun.MuzzlePos;
					self.parentgun.ToDelete = true;
					ActivityMan:GetActivity():SwitchToActor(self.parent,self.cursor:GetController().Player,self.parent.Team);
					self.cursor.ToDelete = true;
					self.Scale = 1;
					self.actionMode = 3;
					local sfx = CreateAEmitter("Dov Boomerang Sound Throw");
					sfx.Pos = self.Pos;
					MovableMan:AddParticle(sfx)
				end
			else
				self.cursor.ToDelete = true;
				self.ToDelete = true;
			end
		elseif self.actionMode == 3 then
			local moveCounter = moveAmount;
			while moveCounter > 0 and self.pathSpot < #self.pathTable do
				local distance = SceneMan:ShortestDistance(self.Pos,self.pathTable[self.pathSpot],self.mapwrapx);
				moveCounter = moveCounter - math.min(moveAmount,distance.Magnitude);
				local checkPos = self.Pos + Vector(math.min(moveAmount,distance.Magnitude),0):RadRotate(distance.AbsRadAngle);
				if SceneMan.SceneWrapsX == true then
					if checkPos.X > SceneMan.SceneWidth then
						checkPos = Vector(checkPos.X - SceneMan.SceneWidth,checkPos.Y);
					elseif checkPos.X < 0 then
						checkPos = Vector(SceneMan.SceneWidth + checkPos.X,checkPos.Y);
					end
				end
				self.Pos = checkPos;
				self.RotAngle = self.RotAngle + (spinAmount*self.flipNum);
				if distance.Magnitude < 1 then
					self.pathSpot = self.pathSpot + 1;
				end
			end
			if self.pathSpot >= #self.pathTable then
				self.pathSpot = self.pathSpot + 1;
				self.actionMode = 4;
			end
		elseif self.actionMode == 4 then
			local distance = SceneMan:ShortestDistance(self.Pos,self.parent.Pos,self.mapwrapx);
			local checkPos = self.Pos + Vector(math.min(moveAmount,distance.Magnitude),0):RadRotate(distance.AbsRadAngle);
			if SceneMan.SceneWrapsX == true then
				if checkPos.X > SceneMan.SceneWidth then
					checkPos = Vector(checkPos.X - SceneMan.SceneWidth,checkPos.Y);
				elseif checkPos.X < 0 then
					checkPos = Vector(SceneMan.SceneWidth + checkPos.X,checkPos.Y);
				end
			end
			self.Pos = checkPos;
			self.RotAngle = self.RotAngle + (spinAmount*self.flipNum);
			if distance.Magnitude <= self.catchDistance then
				local item = CreateHDFirearm("Dov Boomerang");
				item.Sharpness = self.saveSharp;
				self.parent:AddInventoryItem(item);
				if self.parent:IsInventoryEmpty() == false then
					self.parent:GetController():SetState(Controller.WEAPON_CHANGE_PREV,true);
				end
				self.ToDelete = true;
			end
		else
			self.ToDelete = true;
		end
	else
		self.Delete = true;
	end

	if SceneMan:GetTerrMatter(self.Pos.X,self.Pos.Y) == 0 then
		if self.actionMode ~= 2 then
			self:EnableEmission(true);
		end
	else
		if self.actionMode ~= 2 and self.actionMode ~= 4 then
			local sfx = CreateAEmitter("Dov Boomerang Sound Impact");
			sfx.Pos = self.Pos;
			MovableMan:AddParticle(sfx)
			self.pathSpot = #self.pathTable+1;
			self.actionMode = 4
		end
		self:EnableEmission(false);
	end

	for i = self.pathSpot, #self.guideTable do
		if MovableMan:IsParticle(self.guideTable[i]) and self.guideTable[i].PresetName == "Dovuken Trajectory Guide Particle" then
			self.guideTable[i].ToDelete = false;
		end
	end

end

function Destroy(self)

	if MovableMan:IsActor(self.cursor) then
		self.cursor.ToDelete = true;
	end

end