function terraincheck(start,drawpath,optimization,ignore,storage,storage2,storage3)
	storage3 = false;
	for i = 1, math.floor(drawpath.Magnitude/optimization) do
		storage = Vector(start.X,start.Y) + Vector(i*optimization,0):RadRotate(drawpath.AbsRadAngle);
		storage2 = SceneMan:GetTerrMatter(storage.X,storage.Y);
		if storage2 ~= ignore and storage2 ~= 0 then
			storage3 = true
			break;
		end
	end
	return storage3
end

function Create(self)

	self.mapwrapx = SceneMan.SceneWrapsX;
	self.growthTimer = Timer();
	self.directionlistX = {0,0,1,-1};
	self.directionlistY = {1,-1,0,0};
	self.directionHold = {};
	self.canAttack = false;
	self.canThorn = false;
	self.didGrow = false;
	self.huntrange = 300;

	self.growthsPerSecond = 175;

	if self.PresetName == "Particle Creeper Vines Growth" or self.PresetName == "Particle Creeper Vines Growth A" or self.PresetName == "Particle Creeper Vines Growth AX" or self.PresetName == "Particle Creeper Vines Growth X" then
		self.canAttack = true;
		self.attackTimer = Timer();
		self.attackTimer2 = Timer();
		self.attackDelay = 500;
		self.didAttack = false;
	end

	if self.PresetName == "Particle Creeper Vines Growth" or self.PresetName == "Particle Creeper Vines Growth X" then
		self.canThorn = true;
		self.thornChance = 0.0007;
	end

end

function Update(self)

	self.PinStrength = 1000;
	self.ToDelete = false;
	self.ToSettle = false;

	if self.growthTimer.ElapsedSimTimeMS > 0 then
		local growthAmount = math.ceil(self.growthsPerSecond*(self.growthTimer.ElapsedSimTimeMS/1000));
		self.growthTimer:Reset();

		if self.canAttack and self.attackTimer:IsPastSimMS(self.attackDelay) then
			self.attackTimer:Reset();
			self.target = nil;
			for i = 1,MovableMan:GetMOIDCount()-1 do
				self.objectscanner = MovableMan:GetMOFromID(i);
				if self.objectscanner.Pos.Y >= 0 and self.objectscanner.Pos.Y <= SceneMan.SceneHeight and (( self.mapwrapx == false and self.objectscanner.Pos.X >= 0 and self.objectscanner.Pos.X <= SceneMan.SceneWidth ) or self.mapwrapx) then
					self.curdist = SceneMan:ShortestDistance(self.Pos,self.objectscanner.Pos,self.mapwrapx);
					if self.curdist.Magnitude <= self.huntrange and (self.lastscandist == nil or (self.lastscandist ~= nil and self.curdist.Magnitude < self.lastscandist)) then
					--	self.terrvector = Vector(0,0);
					--	self.terrcheck = SceneMan:CastStrengthRay(self.Pos,self.curdist,0,self.terrvector,1,5,self.mapwrapx);
						self.terrcheck = terraincheck(self.Pos,self.curdist,2,5);

						if self.terrcheck == false then
							self.lastscandist = self.curdist.Magnitude;
							self.target = self.objectscanner;
						end
					end
				end
			end
		end

		self.lastscandist = nil;

		if self.target ~= nil and self.target.ID ~= 255 then
			local checkPos = self.Pos + SceneMan:ShortestDistance(self.Pos,self.target.Pos,self.mapwrapx):SetMagnitude(1);
			local matCheck = SceneMan:GetTerrMatter(checkPos.X,checkPos.Y);
			if matCheck == 0 or matCheck == 5 then
				self.moveToPosition = Vector(checkPos.X,checkPos.Y);
				self.didGrow = true;
				if matCheck == 5 then
					self.directionHold[#self.directionHold+1] = self.moveToPosition;
				end
			end
		end

		for i = 1, growthAmount do

			if self.moveToPosition == nil then
				for x = 1, 4 do
					for y = 1, 4 do
						local poX = self.Pos.X+self.directionlistX[x];
						local poY = self.Pos.Y+self.directionlistY[y];
						if self.mapwrapx then
							if poX > SceneMan.SceneWidth then
								poX = 0;
							elseif poX < 0 then
								poX = SceneMan.SceneWidth;
							end
						end
						if poY > SceneMan.SceneHeight or poY < 0 then
							poY = self.Pos.Y;
						end
						if SceneMan:GetTerrMatter(poX,poY) == 0 then
							self.didGrow = true;
							self.directionHold[#self.directionHold+1] = Vector(poX,poY);
						end
					end
				end
				if #self.directionHold == 0 then
					for x = 1, 4 do
						for y = 1, 4 do
							local poX = self.Pos.X+self.directionlistX[x];
							local poY = self.Pos.Y+self.directionlistY[y];
							if self.mapwrapx then
								if poX > SceneMan.SceneWidth then
									poX = 0;
								elseif poX < 0 then
									poX = SceneMan.SceneWidth;
								end
							end
							if poY > SceneMan.SceneHeight or poY < 0 then
								poY = self.Pos.Y;
							end
							if SceneMan:GetTerrMatter(poX,poY) == 5 then
								self.directionHold[#self.directionHold+1] = Vector(poX,poY);
							end
						end
					end
				end
			end

			if #self.directionHold > 0 then
				self.Pos = self.directionHold[math.random(1,#self.directionHold)];

				if self.canAttack then
					if self.attackTimer2:IsPastSimMS(self.attackDelay) then
						if SceneMan:GetMOIDPixel(self.Pos.X,self.Pos.Y) ~= 255 then
							self.attackTimer2:Reset();
							local thorn = CreateMOSParticle("Creeper Vines Thorn");
							thorn.Pos = self.Pos;
							thorn.Sharpness = 1;
							MovableMan:AddParticle(thorn);
							self.didAttack = true;
						end
					end
				end

				if self.didGrow and self.canThorn and not self.didAttack then
					if self.thornChance >= math.random() then
						local thorn = CreateMOSParticle("Creeper Vines Thorn");
						thorn.Pos = self.Pos;
						MovableMan:AddParticle(thorn);
					end
				end

				self.didGrow = false;
				self.didAttack = false;

				local terrpar = CreateMOPixel("Particle Creeper Vines Terrain "..math.random(1,3));
				terrpar.Pos = self.Pos;
				MovableMan:AddParticle(terrpar);
				terrpar.ToSettle = true;
				if self.Sharpness > 0 then
					self.Sharpness = self.Sharpness - 1;
				end

			end
			self.moveToPosition = nil;
			self.directionHold = {};
		end

		if self.Sharpness == 0 then
			self.ToDelete = true;
		end

	end

end

function Destroy(self)

	if self.Sharpness == -1 then
		self.newVine = CreateMOPixel(self.PresetName);
		self.newVine.Pos = self.Pos;
		MovableMan:AddParticle(self.newVine);
	end

end