function Create(self)

	self.mapwrapx = SceneMan.SceneWrapsX;
	self.DTimer = Timer();
	self.STimer = Timer();

end

function Update(self)

	if self:IsActivated() then

		local flipNum = 1;
		if self.HFlipped then
			flipNum = -1;
		end

		if self.DTimer:IsPastSimMS(150) then
			self.DTimer:Reset();
			self.veca = self.MuzzlePos;
			self.vecb = Vector(0,0);
			self.obray = SceneMan:CastObstacleRay(self.MuzzlePos,Vector(120*flipNum,0):RadRotate(self.RotAngle),self.veca,self.vecb,self.RootID,self.Team,0,4);
			self.checkdist = SceneMan:ShortestDistance(self.MuzzlePos,self.veca,self.mapwrapx).Magnitude;
			for particle in MovableMan.Particles do
				if (particle.ClassName == "MOPixel" or particle.ClassName == "MOSParticle" or particle.ClassName == "MOSRotating" or particle.ClassName == "AEmitter") and ( (string.find(particle.PresetName,"Fire") ~= nil) or (string.find(particle.PresetName,"Burn") ~= nil) or (string.find(particle.PresetName,"Pyro") ~= nil) or (string.find(particle.PresetName,"Flame") ~= nil) or (string.find(particle.PresetName,"Flamer") ~= nil) or (string.find(particle.PresetName,"Napalm") ~= nil)) then
					self.distvector = SceneMan:ShortestDistance(self.MuzzlePos,particle.Pos,self.mapwrapx);
					if self.distvector.Magnitude < self.checkdist and SceneMan:ShortestDistance(self.MuzzlePos + Vector(self.distvector.Magnitude*flipNum,0):RadRotate(self.RotAngle),particle.Pos,self.mapwrapx).Magnitude < 30 then
						particle.ToDelete = true;
					end
				end
			end
		end
		if self.STimer:IsPastSimMS(10) then
			self.STimer:Reset();
			local foam = CreateMOPixel("Extinguisher Foam");
			foam.Pos = self.MuzzlePos;
			foam.Vel = Vector(75*flipNum,0):RadRotate(self.RotAngle):DegRotate(15*(math.random(1,100)/100));
			foam.Team = self.Team;
			foam.IgnoresTeamHits = true;
			MovableMan:AddParticle(foam);
		end

	end


end

function Destroy(self)

	for particle in MovableMan.Particles do
		if (particle.ClassName == "MOPixel" or particle.ClassName == "MOSParticle" or particle.ClassName == "MOSRotating" or particle.ClassName == "AEmitter") and ( (string.find(particle.PresetName,"Fire") ~= nil) or (string.find(particle.PresetName,"Burn") ~= nil) or (string.find(particle.PresetName,"Pyro") ~= nil) or (string.find(particle.PresetName,"Flame") ~= nil) or (string.find(particle.PresetName,"Flamer") ~= nil) or (string.find(particle.PresetName,"Napalm") ~= nil) ) then
			if SceneMan:ShortestDistance(self.Pos,particle.Pos,self.mapwrapx).Magnitude < 120 then
				particle.ToDelete = true;
			end
		end
	end

end