function Create(self)
	self.mapwrapx = SceneMan.SceneWrapsX;
	self.switchtimer = Timer();
	self.targettimer = Timer();
	self.fueltimer = Timer();
	self.didswitch = false;
	self.releasedfire = false;
	self.parentplayer = 0;
	self.currentfuel = 0;
	self.lasttargetpos = Vector(0,0);
	self.moveTimer = Timer();

	self.switchtime = 230;
	self.targetchecktime = 100;
	self.detectrange = 700;
	self.switchondestroy = true;
	self.missilefuel = 100;
	self.smarthome = true;
	self.turnsharpness = 6;

	self.halfPi = math.pi*0.5;

	local curdist = 10;
	for i = 1, MovableMan:GetMOIDCount()-1 do
		local gun = MovableMan:GetMOFromID(i);
		if gun.PresetName == "Dov GML" and gun.ClassName == "HDFirearm" and SceneMan:ShortestDistance(self.Pos,ToHDFirearm(gun).MuzzlePos,self.mapwrapx).Magnitude < curdist then
			self.actor = MovableMan:GetMOFromID(gun.RootID);
			if MovableMan:IsActor(self.actor) then
				self.parent = ToActor(self.actor);
				self.parentgun = ToHDFirearm(gun);
				self.currentfuel = self.missilefuel;
				self.Vel = self.parent.Vel + Vector(15,0):RadRotate(self.parent:GetAimAngle(true));
				self.RotAngle = self.parent:GetAimAngle(true);
			end
		end
	end

end

function Update(self)

	if MovableMan:IsActor(self.parent) and self.parent:HasObject("Dov GML") then

		local movePercent = 0;
		if self.moveTimer:IsPastSimMS(0) then
			movePercent = self.moveTimer.ElapsedSimTimeMS/1000;
			self.moveTimer:Reset();
		end

		if self.fueltimer:IsPastSimMS(100) then
			self.fueltimer:Reset();
			self.currentfuel = self.currentfuel - 1;
		end

		if self.currentfuel <= 0 then
			self:GibThis();
		end

		if self.didswitch == false then

			if self.switchtimer.ElapsedSimTimeMS < self.switchtime then
				if self.parent:GetController():IsState(Controller.WEAPON_FIRE) == false then
					self.releasedfire = true;
				end
			end

			if self.switchtimer.ElapsedSimTimeMS >= self.switchtime and self.parent:IsPlayerControlled() and self.releasedfire == false and self.parent:GetController():IsState(Controller.WEAPON_FIRE) then

				self:EnableEmission(true);

				self.controller = CreateACrab("Dovuken Remote Control B");
				self.controller.Team = self.parent.Team;
				self.controller.Pos = self.Pos;
				self.controller.HFlipped = self.parent.HFlipped;
				self.controller:SetAimAngle(self.parent:GetAimAngle(false))
				MovableMan:AddActor(self.controller);

				self.parentplayer = self.parent:GetController().Player;
				ActivityMan:GetActivity():SwitchToActor(self.controller,self.parentplayer,self.parent.Team);

				self.didswitch = true;
				self.switchtimer:Reset();

			elseif self.switchtimer.ElapsedSimTimeMS >= self.switchtime and self.didswitch == false then

				self:EnableEmission(true);

				if MovableMan:IsActor(self.target) then

					if self.smarthome == true then
						local aimVector = SceneMan:ShortestDistance(self.Pos,self.target.Pos,self.mapwrapx);
						self.RotAngle = (Vector(1,0):RadRotate(self.RotAngle) + Vector(self.turnsharpness*movePercent,0):RadRotate(aimVector.AbsRadAngle)).AbsRadAngle;

					else
						local aimVector = SceneMan:ShortestDistance(self.Pos,self.target.Pos,self.mapwrapx);
						self.RotAngle = aimVector.AbsRadAngle;
					end

				elseif not(MovableMan:IsActor(self.target)) and self.targettimer:IsPastSimMS(self.targetchecktime) then
					self.targettimer:Reset();

					for actor in MovableMan.Actors do
						if actor.Team ~= self.Team then
							self.potentialtargetdist = SceneMan:ShortestDistance(self.Pos,actor.Pos,self.mapwrapx);
							self.terrcheck = Vector(0,0);
							if (self.lastdist == nil or (self.lastdist ~= nil and self.potentialtargetdist.Magnitude < self.lastdist)) and self.potentialtargetdist.Magnitude <= self.detectrange and SceneMan:CastStrengthRay(self.Pos,self.potentialtargetdist:SetMagnitude(self.potentialtargetdist.Magnitude-actor.Radius),0,self.terrcheck,5,0,self.mapwrapx) == false then
								self.lastdist = self.potentialtargetdist.Magnitude;
								self.target = actor;
								self.lasttargetpos = Vector(self.target.Pos.X,self.target.Pos.Y);
							end
						end
					end

					if MovableMan:IsActor(self.target) then
						self.targetsound = CreateAEmitter("Dov GML Sound Target");
						self.targetsound.Pos = self.Pos;
						MovableMan:AddParticle(self.targetsound);
					end

				end

			end

		elseif self.didswitch == true then

			if MovableMan:IsActor(self.controller) then

				if self.controller:IsPlayerControlled() == true then

					self.controller.Health = self.currentfuel;
					self.controller.Pos = self.Pos;
					self.RotAngle = self.controller:GetAimAngle(true);

					if self.switchtimer:IsPastSimMS(500) == true then
						if self.controller:GetController():IsState(Controller.WEAPON_FIRE) == false then
							self.releasedfire = true;
						end
					end

					if self.controller:GetController():IsState(Controller.WEAPON_FIRE) and self.releasedfire == true then
						if self.switchondestroy == true then
							ActivityMan:GetActivity():SwitchToActor(self.parent,self.parentplayer,self.parent.Team);
						end
						self:GibThis();
						self.controller.ToDelete = true;
					end

					if self.controller:GetController():IsState(Controller.BODY_CROUCH) then
						self.didswitch = false;
						ActivityMan:GetActivity():SwitchToActor(self.parent,self.parentplayer,self.parent.Team);
						self.controller.ToDelete = true;
					end

				else
					self.didswitch = false;
					self.controller.ToDelete = true;
				end

			else
				self:GibThis();
			end

		end

	else
		self:GibThis();
	end

end

function Destroy(self)

	if MovableMan:IsActor(self.controller) then
		if MovableMan:IsActor(self.parent) and self.switchondestroy == true then
			ActivityMan:GetActivity():SwitchToActor(self.parent,self.parentplayer,self.parent.Team);
		end
		self.controller.ToDelete = true;
	end

end