function yesorno(a)
	if a == true then
		return 1
	else
		return 0
	end
end

function Create(self)
	self.mapwrapx = SceneMan.SceneWrapsX;
	self.firemode = 0; -- 0 is inactive, 1 is pull, 2 is launch, 3 is drop. This is NOT to be edited.
	self.tractortimer = Timer();
	self.terrcheck = Vector(0,0);

	self.pulltarget = nil;
	self.pickupsetangle = nil;
	self.pickuptarget = nil;
	self.pushtarget = nil;

----------------------------------------
----- Settings

	self.power = 600; -- the maximum weight of an object that the gravity gun can move

	self.pullspeed = 30;
	self.pullspeedfade = true; -- if the pull speed should weaken over distance
	self.pullbyaccel = false; -- if the gravity gun should pull an object using accerlation
	self.tractorbeamlength = 400; -- length of tractor beam
	self.tractorbeamwidth = 1; -- width or thickness of tractor beam
	self.tractordelay = 10; -- time between tractor beam checks for optimization purposes

	self.pickuprange = 2; -- radius of pickup area

	self.pushspeed = 50;
	self.launchbeamlength = 50; -- length of launch beam
	self.launchbeamwidth = 1; -- width or thickness of launch beam

	self.beameffectspacing = 8;

----------------------------------------

	self.weaponname = "Dov Gravity Gun";
	self.modulename = "Dovuken.rte";

	self.pickupsound = "Dov Gravity Gun Sound Pickup";
	self.dropsound = "Dov Gravity Gun Sound Drop";
	self.launchsound = "Dov Gravity Gun Sound Fire";
		self.launchsoundvariations = 3;
	self.dryfiresound = "Dov Gravity Gun Sound Dry Fire";

	self.muzzleglowname = "Particle Dov Gravity Gun Glow";
	self.reticlename = "Particle Dov Gravity Gun Reticle Glow";
	self.beamendglowname = "Particle Dov Gravity Gun Launch End Glow";
	self.beamglowname = "Particle Dov Gravity Gun Launch Glow";

	for i = 1,MovableMan:GetMOIDCount()-1 do
		local gun = MovableMan:GetMOFromID(i);
		if gun.PresetName == self.weaponname and gun.ClassName == "HDFirearm" and SceneMan:ShortestDistance(self.Pos,ToHDFirearm(gun).MuzzlePos,self.mapwrapx).Magnitude < 10 then
			local actor = MovableMan:GetMOFromID(gun.RootID);
			if MovableMan:IsActor(actor) then
				self.parent = ToActor(actor);
				self.parentgun = ToHDFirearm(gun);
				self.firemode = 1;
				break;
			end
		end
	end

	self.part = nil;

end

function Update(self)

	if MovableMan:IsActor(self.parent) and self.parentgun.ID ~= 255 and self.parent:HasObject(self.weaponname) then
		self.ToDelete = false;
		self.ToSettle = false;
		self.PinStrength = 1000;
		self.Pos = self.parentgun.MuzzlePos + Vector(2,0):RadRotate(self.parent:GetAimAngle(true));

		if not(self.parent:GetController():IsState(Controller.WEAPON_FIRE)) then
			if self.parent:GetController():IsState(Controller.PIE_MENU_ACTIVE) then
				self.soundfx = CreateAEmitter(self.dropsound,self.modulename);
				self.soundfx.Pos = self.parentgun.MuzzlePos;
				MovableMan:AddParticle(self.soundfx);
				self.soundfx = nil;
				self.firemode = 3;
				self.ToDelete = true;
			else
				self.firemode = 2;
			end
		end

		if not(MovableMan:IsParticle(self.gravglow)) then
			self.gravglow = CreateMOPixel(self.muzzleglowname,self.modulename);
			self.gravglow.Pos = self.parentgun.MuzzlePos;
			MovableMan:AddParticle(self.gravglow);
		elseif MovableMan:IsParticle(self.gravglow) and self.gravglow.PresetName == self.muzzleglowname then
			self.gravglow.ToDelete = false;
			self.gravglow.ToSettle = false;
			self.gravglow.PinStrength = 1000;
			self.gravglow.Pos = self.parentgun.MuzzlePos;
		end

		if self.firemode == 1 and self.pickuptarget == nil then
			self.obvectorA = Vector(0,0);
			self.obvectorB = Vector(self.tractorbeamlength,0):RadRotate(self.parent:GetAimAngle(true));
			self.obstacleray = SceneMan:CastObstacleRay(self.parentgun.MuzzlePos,Vector(self.tractorbeamlength,0):RadRotate(self.parent:GetAimAngle(true)),self.obvectorA,self.obvectorB,self.parent.ID,-2,0,1);

			if not(MovableMan:IsParticle(self.reticle)) then
				self.reticle = CreateMOPixel(self.reticlename,self.modulename);
				self.reticle.Pos = self.obvectorB;
				MovableMan:AddParticle(self.reticle);
			elseif MovableMan:IsParticle(self.reticle) and self.reticle.PresetName == self.reticlename then
				self.reticle.ToDelete = false;
				self.reticle.ToSettle = false;
				self.reticle.PinStrength = 1000;
				self.reticle.Pos = self.obvectorB;
			end
		else
			if MovableMan:IsParticle(self.reticle) then
				self.reticle.ToDelete = true;
			end
		end

		if self.firemode == 1 then

			if self.pickuptarget == nil then

				if self.tractortimer:IsPastSimMS(self.tractordelay) then

					self.tractortimer:Reset();

					self.pulltarget = nil;
					self.lastdist = nil;
					self.radcheck = nil;
					self.overallradius = nil;

					for actor in MovableMan.Actors do
						if actor.ID ~= self.parent.ID and actor.Mass <= self.power then
							self.distcheck = SceneMan:ShortestDistance(actor.Pos,self.parentgun.MuzzlePos,self.mapwrapx);
							if self.distcheck.Magnitude <= self.tractorbeamlength and (self.lastdist == nil or (self.lastdist ~= nil and self.distcheck.Magnitude < self.lastdist)) and SceneMan:ShortestDistance(self.parentgun.MuzzlePos + Vector(self.distcheck.Magnitude,0):RadRotate(self.parent:GetAimAngle(true)),actor.Pos,self.mapwrapx).Magnitude <= (self.tractorbeamwidth + actor.Radius) then
								self.lastdist = self.distcheck.Magnitude;
								self.pulltarget = actor;
							end
						end
					end

					for item in MovableMan.Items do
						if item.Mass <= self.power then
							self.distcheck = SceneMan:ShortestDistance(item.Pos,self.parentgun.MuzzlePos,self.mapwrapx);
							if self.distcheck.Magnitude <= self.tractorbeamlength and (self.lastdist == nil or (self.lastdist ~= nil and self.distcheck.Magnitude < self.lastdist)) and SceneMan:ShortestDistance(self.parentgun.MuzzlePos + Vector(self.distcheck.Magnitude,0):RadRotate(self.parent:GetAimAngle(true)),item.Pos,self.mapwrapx).Magnitude <= (self.tractorbeamwidth + item.Radius) then
								self.lastdist = self.distcheck.Magnitude;
								self.pulltarget = item;
							end
						end
					end

					for particle in MovableMan.Particles do
						if (particle.ClassName == "MOSRotating" or particle.ClassName == "AEmitter") and particle.Mass <= self.power then
							self.distcheck = SceneMan:ShortestDistance(particle.Pos,self.parentgun.MuzzlePos,self.mapwrapx);
							if self.distcheck.Magnitude <= self.tractorbeamlength and (self.lastdist == nil or (self.lastdist ~= nil and self.distcheck.Magnitude < self.lastdist)) and SceneMan:ShortestDistance(self.parentgun.MuzzlePos + Vector(self.distcheck.Magnitude,0):RadRotate(self.parent:GetAimAngle(true)),particle.Pos,self.mapwrapx).Magnitude <= (self.tractorbeamwidth + particle.Radius) then
								self.lastdist = self.distcheck.Magnitude;
								self.pulltarget = particle;
							end
						end
					end

					self.moray = SceneMan:CastMORay(self.Pos,Vector(self.tractorbeamlength,0):RadRotate(self.parent:GetAimAngle(true)),self.parent.ID,-2,0,false,1);
					if self.moray ~= 255 then
						self.part = MovableMan:GetMOFromID(self.moray);
						self.body = MovableMan:GetMOFromID(self.part.RootID);
						if self.body.ID ~= self.parent.ID and self.body.Mass <= self.power then
							self.distcheck = SceneMan:ShortestDistance(self.part.Pos,self.parentgun.MuzzlePos,self.mapwrapx);
							if self.distcheck.Magnitude <= self.tractorbeamlength and (self.lastdist == nil or (self.lastdist ~= nil and self.distcheck.Magnitude < self.lastdist)) and SceneMan:ShortestDistance(self.parentgun.MuzzlePos + Vector(self.distcheck.Magnitude,0):RadRotate(self.parent:GetAimAngle(true)),self.part.Pos,self.mapwrapx).Magnitude <= (self.tractorbeamwidth + self.part.Radius) then
								self.lastdist = self.distcheck.Magnitude;
								self.pulltarget = self.body;
							end
						end
					end

				end

				if self.pulltarget ~= nil and SceneMan:CastStrengthRay(self.parentgun.MuzzlePos,Vector(SceneMan:ShortestDistance(self.parentgun.MuzzlePos,self.pulltarget.Pos,self.mapwrapx).Magnitude-self.pulltarget.Radius,0):RadRotate(self.parent:GetAimAngle(true)),0,self.terrcheck,2,0,self.mapwrapx) == false then
					self.pulltargetdist = SceneMan:ShortestDistance(self.pulltarget.Pos,self.Pos,self.mapwrapx);
					self.pulltarget.Vel = (self.pulltarget.Vel*yesorno(self.pullbyaccel)) + self.pulltargetdist:SetMagnitude(self.pullspeed*((1-(self.pulltargetdist.Magnitude/self.tractorbeamlength))*yesorno(self.pullspeedfade)));


					if self.pulltarget.GetsHitByMOs == true then
						for i = 1, MovableMan:GetMOIDCount()-1 do
							self.part = MovableMan:GetMOFromID(i);
							if self.part.RootID == self.pulltarget.ID then
								self.radcheck = SceneMan:ShortestDistance(self.pulltarget.Pos,self.part.Pos,self.mapwrapx).Magnitude + self.part.Radius;
								if self.overallradius == nil or (self.overallradius ~= nil and self.radcheck > self.overallradius) then
									self.overallradius = self.radcheck;
								end
							end
						end
					else
						self.overallradius = self.pulltarget.Radius;
					end


					if self.pulltarget.PinStrength <= 0 and SceneMan:ShortestDistance(self.parentgun.MuzzlePos,self.pulltarget.Pos+self.pulltarget.Vel+(SceneMan.GlobalAcc * TimerMan.DeltaTimeSecs),self.mapwrapx).Magnitude <= (self.pickuprange + self.overallradius) then
						self.soundfx = CreateAEmitter(self.pickupsound,self.modulename);
						self.soundfx.Pos = self.parentgun.MuzzlePos;
						MovableMan:AddParticle(self.soundfx);
						self.soundfx = nil;
						self.pickuptarget = self.pulltarget;
						self.pickupsetangle = self.pickuptarget.RotAngle;
					end
				end

			elseif self.pickuptarget ~= nil then
				if MovableMan:IsActor(self.pickuptarget) or MovableMan:IsDevice(self.pickuptarget) or MovableMan:IsParticle(self.pickuptarget) or (self.pickuptarget.GetsHitByMOs == true and self.pickuptarget.ID ~= 255) then
					self.pickuptarget.Vel = self.parent.Vel;
					self.pickuptarget.Pos = self.parentgun.MuzzlePos + Vector(self.overallradius+1,0):RadRotate(self.parent:GetAimAngle(true));
					self.pickuptarget.AngularVel = 0;
					self.pickuptarget.RotAngle = self.pickupsetangle;
				else
					self.ToDelete = true;
				end
			end

		elseif self.firemode == 2 then

			if self.pickuptarget == nil then

				for actor in MovableMan.Actors do
					if actor.ID ~= self.parent.ID and actor.Mass <= self.power then
						self.distcheck = SceneMan:ShortestDistance(actor.Pos,self.parentgun.MuzzlePos,self.mapwrapx);
						if self.distcheck.Magnitude <= self.launchbeamlength and (self.lastdist == nil or (self.lastdist ~= nil and self.distcheck.Magnitude < self.lastdist)) and SceneMan:ShortestDistance(self.parentgun.MuzzlePos + Vector(self.distcheck.Magnitude,0):RadRotate(self.parent:GetAimAngle(true)),actor.Pos,self.mapwrapx).Magnitude <= (self.launchbeamwidth + actor.Radius) then
							self.lastdist = self.distcheck.Magnitude;
							self.pushtarget = actor;
						end
					end
				end

				for item in MovableMan.Items do
					if item.Mass <= self.power then
						self.distcheck = SceneMan:ShortestDistance(item.Pos,self.parentgun.MuzzlePos,self.mapwrapx);
						if self.distcheck.Magnitude <= self.launchbeamlength and (self.lastdist == nil or (self.lastdist ~= nil and self.distcheck.Magnitude < self.lastdist)) and SceneMan:ShortestDistance(self.parentgun.MuzzlePos + Vector(self.distcheck.Magnitude,0):RadRotate(self.parent:GetAimAngle(true)),item.Pos,self.mapwrapx).Magnitude <= (self.launchbeamwidth + item.Radius) then
							self.lastdist = self.distcheck.Magnitude;
							self.pushtarget = item;
						end
					end
				end

				for particle in MovableMan.Particles do
					if (particle.ClassName == "MOSRotating" or particle.ClassName == "AEmitter") and particle.Mass <= self.power then
						self.distcheck = SceneMan:ShortestDistance(particle.Pos,self.parentgun.MuzzlePos,self.mapwrapx);
						if self.distcheck.Magnitude <= self.launchbeamlength and (self.lastdist == nil or (self.lastdist ~= nil and self.distcheck.Magnitude < self.lastdist)) and SceneMan:ShortestDistance(self.parentgun.MuzzlePos + Vector(self.distcheck.Magnitude,0):RadRotate(self.parent:GetAimAngle(true)),particle.Pos,self.mapwrapx).Magnitude <= (self.launchbeamwidth + particle.Radius) then
							self.lastdist = self.distcheck.Magnitude;
							self.pushtarget = particle;
						end
					end
				end

				self.moray = SceneMan:CastMORay(self.Pos,Vector(self.tractorbeamlength,0):RadRotate(self.parent:GetAimAngle(true)),self.parent.ID,-2,0,false,1);
				if self.moray ~= 255 then
					self.part = MovableMan:GetMOFromID(self.moray);
					self.body = MovableMan:GetMOFromID(self.part.RootID);
					if self.body.ID ~= self.parent.ID and self.body.Mass <= self.power then
						self.distcheck = SceneMan:ShortestDistance(self.part.Pos,self.parentgun.MuzzlePos,self.mapwrapx);
						if self.distcheck.Magnitude <= self.launchbeamlength and (self.lastdist == nil or (self.lastdist ~= nil and self.distcheck.Magnitude < self.lastdist)) and SceneMan:ShortestDistance(self.parentgun.MuzzlePos + Vector(self.distcheck.Magnitude,0):RadRotate(self.parent:GetAimAngle(true)),self.part.Pos,self.mapwrapx).Magnitude <= (self.launchbeamwidth + self.part.Radius) then
							self.lastdist = self.distcheck.Magnitude;
							self.pulltarget = self.body;
						end
					end
				end

			elseif self.pickuptarget ~= nil then
				if MovableMan:IsActor(self.pickuptarget) or MovableMan:IsDevice(self.pickuptarget) or MovableMan:IsParticle(self.pickuptarget) or (self.pickuptarget.GetsHitByMOs == true and self.pickuptarget.ID ~= 255) then
					self.pushtarget = self.pickuptarget;
				end
			end


			if self.pushtarget == nil then
				self.soundfx = CreateAEmitter(self.dryfiresound,self.modulename);
				self.soundfx.Pos = self.parentgun.MuzzlePos;
				MovableMan:AddParticle(self.soundfx);
				self.soundfx = nil;
			elseif self.pushtarget ~= nil and SceneMan:CastStrengthRay(self.parentgun.MuzzlePos,Vector(SceneMan:ShortestDistance(self.parentgun.MuzzlePos,self.pushtarget.Pos,self.mapwrapx).Magnitude-self.pushtarget.Radius,0):RadRotate(self.parent:GetAimAngle(true)),0,self.terrcheck,2,0,self.mapwrapx) == false then
				self.soundfx = CreateAEmitter(self.launchsound.." "..self.launchsoundvariations,self.modulename);
				self.soundfx.Pos = self.parentgun.MuzzlePos;
				MovableMan:AddParticle(self.soundfx);
				self.soundfx = nil;

				self.launchbeamfxlength = math.ceil(SceneMan:ShortestDistance(self.parentgun.MuzzlePos,self.pushtarget.Pos,self.mapwrapx).Magnitude/self.beameffectspacing);
				for i = 1, self.launchbeamfxlength do
					if i == self.launchbeamfxlength or i == 1 then
						self.visualfx = CreateMOPixel(self.beamendglowname,self.modulename);
					else
						self.visualfx = CreateMOPixel(self.beamglowname,self.modulename);
					end
					self.visualfx.Pos = self.parentgun.MuzzlePos + Vector(i*self.beameffectspacing,0):RadRotate(self.parent:GetAimAngle(true));
					MovableMan:AddParticle(self.visualfx);
				end

				self.pushtarget.Vel = self.parent.Vel + Vector(self.pushspeed,0):RadRotate(self.parent:GetAimAngle(true));
			end


			self.ToDelete = true;
		end
	else
		self.ToDelete = true;
	end

end

function Destroy(self)

	if MovableMan:IsParticle(self.gravglow) then
		self.gravglow.ToDelete = true;
	end

	if MovableMan:IsParticle(self.reticle) then
		self.reticle.ToDelete = true;
	end

end