function Create(self)

	self.mapwrapx = SceneMan.SceneWrapsX;
	self.modetimer = Timer();
	self.mode = 0;
	self.exploded = false;
	self.lastpos = self.Pos;
	self.ignoreid = 255;
	self.stuck = false;

----------------------------------------
----- Settings

	self.modedelaytime = 200;
	self.dettime = 3000;

----------------------------------------

	self.curdist = 10;
	for i = 1,MovableMan:GetMOIDCount()-1 do
		local gun = MovableMan:GetMOFromID(i);
		if gun.PresetName == "Dov M319 IGL" and gun.ClassName == "HDFirearm" and SceneMan:ShortestDistance(self.Pos,ToHDFirearm(gun).MuzzlePos,self.mapwrapx).Magnitude < self.curdist then
			self.parentgun = ToHDFirearm(gun);
			if self.parentgun.HFlipped == false then
				self.flipnum = 1;
			else
				self.flipnum = -1;
			end
			self.Vel = self.parentgun.Vel + Vector(30*self.flipnum,0):RadRotate(self.parentgun.RotAngle);
			self.flipnum = nil;
			break;
		end
	end

end

function Update(self)

	self.ToDelete = false;
	self.ToSettle = false;
	self:NotResting();
	self.Health = 100;

	if self.parentgun ~= nil and self.parentgun.ID ~= 255 then
		self.parent = nil;
		self.actor = MovableMan:GetMOFromID(self.parentgun.RootID);
		if MovableMan:IsActor(self.actor) == true then
			self.parent = ToActor(self.actor);
			self.ignoreid = self.parent.ID;
		else
			self.mode = 1;
		end
		if self.mode == 0 then
			if MovableMan:IsActor(self.parent) == true then
				if self.parent:GetController():IsState(Controller.WEAPON_FIRE) == false then
					if self.modetimer:IsPastSimMS(self.modedelaytime) == false then
						self.mode = 1;
						self.modetimer:Reset();
					else
						if self.parent:GetController():IsState(Controller.PIE_MENU_ACTIVE) == true then
							local explosion = CreateMOSRotating("Dov M319 IGL Flash");
							explosion.Pos = self.Pos;
							explosion:GibThis();
							MovableMan:AddParticle(explosion);
							self.exploded = true;
							self.ToDelete = true
						else
							local explosion = CreateMOSRotating("Dov M319 IGL Explosion");
							explosion.Pos = self.Pos;
							explosion:GibThis();
							MovableMan:AddParticle(explosion);
							self.exploded = true;
							self.ToDelete = true
						end
					end
				end
			else
				self.mode = 1;
			end
		elseif self.mode == 1 then

			self.HitsMOs = false;

			if self.modetimer:IsPastSimMS(self.dettime) == true then
				local explosion = CreateMOSRotating("Dov M319 IGL Explosion");
				explosion.Pos = self.Pos;
				explosion:GibThis();
				MovableMan:AddParticle(explosion);
				self.exploded = true;
				self.ToDelete = true
			end

			if self.stuck == false then

				self.stickobject = SceneMan:CastMORay(self.Pos,Vector(3,0):RadRotate(self.Vel.AbsRadAngle),self.ignoreid,self.Team,0,false,0);
				self.clingpos = Vector(0,0);

				if self.stickobject ~= 255 then
					self.sticktarget = MovableMan:GetMOFromID(self.stickobject);
					self.stickpositionX = self.Pos.X-self.sticktarget.Pos.X;
					self.stickpositionY = self.Pos.Y-self.sticktarget.Pos.Y;
					self.stickrotation = self.sticktarget.RotAngle;
					self.stickdirection = self.RotAngle;
					self.startflipped = self.sticktarget.HFlipped;
					self.stuck = true;
				elseif SceneMan:CastStrengthRay(self.Pos,Vector(12,0):RadRotate(self.Vel.AbsRadAngle),0,self.clingpos,0,0,self.mapwrapx) == true then
					self.Vel = Vector(0,0);
					self.PinStrength = 1000;
					local positionsetter = SceneMan:ShortestDistance(self.Pos,self.clingpos,self.mapwrapx);
					self.Pos = self.Pos + Vector(positionsetter.X,positionsetter.Y):SetMagnitude(self.Vel.Magnitude - 1);
					self.stuck = true;
				end
			else
				if self.sticktarget ~= nil and self.sticktarget.ID ~= 255 then
					self.Pos = self.sticktarget.Pos + Vector(self.stickpositionX,self.stickpositionY):RadRotate(self.sticktarget.RotAngle-self.stickrotation);
					self.RotAngle = self.stickdirection+(self.sticktarget.RotAngle-self.stickrotation);
					self.Vel = Vector(0,0);
					self.PinStrength = 1000;
				elseif self.sticktarget ~= nil and self.sticktarget.ID == 255 then
					selfstuck = false;
					self.PinStrength = 0;
				end

			end

		end
	else
		self.ToDelete = true;
	end

	self.lastpos = self.Pos;

end

function Destroy(self)

	if self.exploded == false then
		explosion = CreateMOSRotating("Dov M319 IGL Explosion");
		explosion.Pos = self.lastpos;
		explosion:GibThis();
		MovableMan:AddParticle(explosion);
	end

end