function Create(self)

	self.DelayTimer = Timer();
	self.ChargeTimer = Timer();
	self.AnimTimer = Timer();
	self.chargeIntervals = 11;
	self.charge = 0;
	self.fired = false;
	self.frameCounter = 0;

	self.fireSpread = (30/360)*math.pi*2;
	self.particlespercharge = 4;
	if self.PresetName == "Dov Particle Accelerator X" then
		self.chargetime = 3000;
	else
	 	self.chargetime = 500;
	end
	self.fireDelay = 500;

	self.halfSpread = self.fireSpread * 0.5;
	self.chargeTimePerInterval = self.chargetime/self.chargeIntervals;

end

function Update(self)

	if self:IsActivated() then

		if self.charge > 1 then
			if self.Magazine ~= nil then
				self.Magazine.RoundCount = self.charge - 1;
			end
		end

		if self.DelayTimer:IsPastSimMS(self.fireDelay) then
			self.fired = false;

			if self.charge == 0 then
				self.charge = 1;
			end

			if self.ChargeTimer:IsPastSimMS(self.chargeTimePerInterval) then
				self.ChargeTimer:Reset();
				self.charge = self.charge + 1;
				if self.charge < self.chargeIntervals and MovableMan:IsParticle(self.chargeSound) then
					self.chargeSound.ToDelete = true;
					self.chargeSound = nil;
				end
			end

			if MovableMan:IsParticle(self.chargeSound) then
				self.chargeSound.ToDelete = false;
				self.chargeSound.ToSelete = false;
				self.chargeSound.Pos = self.MuzzlePos;
			else
				self.chargeSound = CreateAEmitter("Dovuken Particle Accelerator Sound Charge "..math.min(self.charge,11));
				self.chargeSound.Pos = self.MuzzlePos;
				MovableMan:AddParticle(self.chargeSound);
			end

			if self.AnimTimer:IsPastSimMS(60-((self.charge/self.chargeIntervals)*50)) then
				self.AnimTimer:Reset();
				self.frameCounter = self.frameCounter + 1;
				if self.frameCounter > 10 then
					self.frameCounter = 0;
				end
				if self.Magazine ~= nil then
					self.Magazine.Frame = self.frameCounter;
				end
			end
		end

	else

		self.ChargeTimer:Reset();

		if self.fired == false and self.charge > 0 then

			self.DelayTimer:Reset();

			self.frameCounter = 0;
			if self.Magazine ~= nil then
				self.Magazine.Frame = 0;
				self.Magazine.RoundCount = -1;
			end

			if MovableMan:IsParticle(self.chargeSound) then
				self.chargeSound.ToDelete = true;
			end

			for i = 1, self.charge*self.particlespercharge do
				local chargeBlast = CreateMOPixel("Dovuken Particle Particle Accelerator");
				chargeBlast.Pos = self.MuzzlePos + Vector(10*math.random(),0):RadRotate(math.random()*math.pi*2);
				local flipNum = 1;
				if self.HFlipped == true then
					flipNum = -1;
				end
				chargeBlast:SetWhichMOToNotHit(MovableMan:GetMOFromID(self.RootID),-1);
				if self.Sharpness == 0 then
					chargeBlast.Vel = Vector(150*flipNum,0):RadRotate(self.RotAngle);
				elseif self.Sharpness == 1 then
					chargeBlast.Vel = Vector(150*flipNum,0):RadRotate(self.RotAngle):RadRotate((self.halfSpread*-1)+(math.random()*self.fireSpread));
				else
					chargeBlast.Vel = Vector(150*flipNum,0):RadRotate(math.random()*math.pi*2);
				end

				chargeBlast.Team = self.Team;
				chargeBlast.IgnoresTeamHits = true;
				MovableMan:AddParticle(chargeBlast);
				chargeBlast = nil;
			end

			local soundfx = CreateAEmitter("Dovuken Particle Accelerator Sound Fire");
			soundfx.Pos = self.MuzzlePos;
			MovableMan:AddParticle(soundfx);

			if self.charge > 200 then
				self:GibThis();
			end

			self.charge = 0;

		end

		self.fired = true;

	end

end