function Create(self)

	self.mapwrapx = SceneMan.SceneWrapsX;
	self.scanrange = 800;
	self.lastGunVel = Vector(0,0);
	self.dataTable = {};
	self.teamTable = {"RED","GREEN","BLUE","YELLOW"};
	self.aiTable = {"NONE","SENTRY","PATROL","GOTO","BRAINHUNT","GOLDDIG","RETURN","STAY","SCUTTLE","DELIVER","COUNT"};

	for i = 1, MovableMan:GetMOIDCount()-1 do
		local gun = MovableMan:GetMOFromID(i);
		if gun.ClassName == "HDFirearm" and gun.PresetName == "Advanced D-Scanner" and SceneMan:ShortestDistance(self.Pos,ToHDFirearm(gun).MuzzlePos,self.mapwrapx).Magnitude < 5 then

			if gun.Sharpness == 0 then
				local actor = MovableMan:GetMOFromID(gun.RootID);
				if MovableMan:IsActor(actor) then
					self.parent = ToActor(actor);
					self.parentgun = ToHDFirearm(gun);

					local raycast = SceneMan:CastMORay(self.Pos,Vector(self.scanrange,0):RadRotate(self.parent:GetAimAngle(true)),self.parent.ID,-2,0,false,2);

					if raycast ~= 255 then
						self.target = MovableMan:GetMOFromID(MovableMan:GetMOFromID(raycast).RootID);
						gun.Sharpness = 1;

						self.dataTable[1] = self.target.PresetName;
						self.dataTable[2] = self.target.ClassName;
						self.dataTable[3] = 0;
						self.dataTable[4] = 0;
						self.dataTable[5] = Vector(0,0);
						self.dataTable[6] = Vector(0,0);
						self.dataTable[7] = 0;

						local soundfx = CreateAEmitter("Dov Scanner Gun Sound Fire "..math.ceil(math.random()*2));
						soundfx.Pos = self.parentgun.MuzzlePos;
						MovableMan:AddParticle(soundfx);

						local visualfx = CreateMOSRotating("Dov Scanner Gun FX Ring");
						visualfx.Pos = self.target.Pos;
						visualfx.Scale = 0;

						local overallRadius = self.target.Radius;

						for i = 1, MovableMan:GetMOIDCount()-1 do
							local part = MovableMan:GetMOFromID(i);
							if part.RootID == self.target.ID then
								if part.ID ~= self.target.ID and part.ClassName ~= "HDFirearm" and part.ClassName ~= "TDExplosive" and part.ClassName ~= "HeldDevice" then
									local radiusCheck = SceneMan:ShortestDistance(self.target.Pos,part.Pos,self.mapwrapx).Magnitude + part.Radius;
									if radiusCheck > overallRadius then
										overallRadius = radiusCheck;
									end
								end
							end
						end
						print(overallRadius);
						visualfx.Sharpness = overallRadius;
						MovableMan:AddParticle(visualfx);

					else
						local soundfx = CreateAEmitter("Dov Scanner Gun Sound Failed");
						soundfx.Pos = self.parentgun.MuzzlePos;
						MovableMan:AddParticle(soundfx);
					end

				end
			else
				gun.Sharpness = 0;
				self.ToDelete = true;
			end



		end
	end

end

function Update(self)

	self.ToDelete = false;
	self.ToSettle = false;

	if MovableMan:IsActor(self.parent) and self.parentgun.ID ~= 255 and self.parentgun.RootID ~= self.parentgun.ID and self.parent:HasObject("Advanced D-Scanner") then

		if self.target ~= nil and self.parentgun.Sharpness == 1 then


			if self.parent:IsPlayerControlled() then

				self.parentplayer = self.parent:GetController().Player;

				local textsetter = "Name : "..self.dataTable[1].."\nClass : "..self.dataTable[2];

				self.dataTable[3] = 0;
				self.dataTable[8] = "none";
				self.dataTable[7] = 0;

				self.dataTable[10] = 0;
				self.dataTable[11] = 0;

				self.dataTable[12] = "none";

				self.dataTable[13] = 0;
				self.dataTable[14] = "?";
				self.dataTable[15] = 0;

				if self.target.ID ~= 255 then

					if self.target:IsActor() then
						textsetter = textsetter.."\nHealth : "..ToActor(self.target).Health;

						self.dataTable[12] = self.aiTable[ToActor(self.target).AIMode+1];

						self.dataTable[15] = (ToActor(self.target):GetAimAngle(true)/math.pi)*360;

					end

					self.dataTable[4] = self.target.Age;
					self.dataTable[5] = self.target.Pos;
					self.dataTable[6] = self.target.Vel;

					self.dataTable[7] = math.floor(SceneMan:ShortestDistance(self.parent.Pos,self.target.Pos,self.mapwrapx).Magnitude);

					if self.target.Team ~= nil then
						if self.target.Team >= 0 and self.target.Team <= 3 then
							self.dataTable[8] = self.teamTable[self.target.Team+1];
						end
					end

					self.dataTable[9] = "none";
					self.dataTable[13] = self.target.Radius;

					for i = 1, MovableMan:GetMOIDCount()-1 do
						local part = MovableMan:GetMOFromID(i);
						if part.RootID == self.target.ID then
							self.dataTable[3] = self.dataTable[3] + 1;
							if part.ID ~= self.target.ID and (part.ClassName == "HDFirearm" or part.ClassName == "TDExplosive") then
								if Vector(part.Vel.X,part.Vel.Y) ~= Vector(self.lastGunVel.X,self.lastGunVel.Y) then
									self.dataTable[9] = part.PresetName;
									self.lastGunVel = Vector(part.Vel.X,part.Vel.Y);
								end
							else
								if part.ClassName ~= "HeldDevice" then
									local radiusCheck = SceneMan:ShortestDistance(self.target.Pos,part.Pos,self.mapwrapx).Magnitude + part.Radius;
									if self.dataTable[13] < radiusCheck then
										self.dataTable[13] = radiusCheck;
									end
								end
							end
						end
					end

					self.dataTable[10] = self.target.Mass;
					self.dataTable[11] = self.target:GetGoldValue(0,0);

					if self.target.HFlipped == false then
						self.dataTable[14] = "RIGHT";
					else
						self.dataTable[14] = "LEFT";
					end


				else
					textsetter = textsetter.."\n(DESTROYED)"
				end

				textsetter = textsetter.."\nParts : "..self.dataTable[3];
				textsetter = textsetter.."\nAge: "..math.floor(self.dataTable[4]/1000).."s";
				textsetter = textsetter.."\nPosition: ".."x"..math.floor(self.dataTable[5].X).." y"..math.floor(self.dataTable[5].Y);
				textsetter = textsetter.."\nSpeed: "..math.floor(self.dataTable[6].Magnitude);
				textsetter = textsetter.."\nDistance: "..self.dataTable[7];
				textsetter = textsetter.."\nTeam : "..self.dataTable[8];
				textsetter = textsetter.."\nEquipped : "..self.dataTable[9];
				textsetter = textsetter.."\nMass : "..self.dataTable[10];
				textsetter = textsetter.."\nGoldValue : "..self.dataTable[11];
				textsetter = textsetter.."\nDiameter : "..math.floor(self.dataTable[13]*2);
				textsetter = textsetter.."\nFacing : "..self.dataTable[14];
				textsetter = textsetter.."\nAimAngle : "..math.floor(self.dataTable[15]).."d";
				textsetter = textsetter.."\nAI : "..self.dataTable[12];

				FrameMan:ClearScreenText(self.parentplayer);
				FrameMan:SetScreenText(textsetter,self.parentplayer,0,1,false);

			end


		else
			self.ToDelete = true;
		end

	else
		self.ToDelete = true;
	end

end