function Create(self)
	self.trackerID = math.floor(math.random()*1000000);
	self.delayTimer = Timer();
	self.turnTimer = Timer();
	self.negativeNum = 1;
	self.reloaded = false;
	self.ammoCounter = 0;

	self.adjustmentAmount = 0.05;

	self.bulletTable = {};
	self.targetTable = {};
end

function Update(self)

	if self.HFlipped == false then
		self.negativeNum = 1;
	else
		self.negativeNum = -1;
	end

	local actor = MovableMan:GetMOFromID(self.RootID);
	if MovableMan:IsActor(actor) and ToActor(actor):GetController():IsState(Controller.AIM_SHARP) then
		if self.delayTimer:IsPastSimMS(50) then
			self.delayTimer:Reset();

			if self.Sharpness == 1 or (self.target ~= null and self.target.ID == 255) then
				self.target = null;
			end

			local longDist = 800;
			local shortDist = 98;
			local totalDist = longDist + shortDist + 1;

			if self.target == null then
				for i = 1, MovableMan:GetMOIDCount()-1 do
					local mo = MovableMan:GetMOFromID(i);
					if mo.Team ~= self.Team or mo.ClassName == "TDExplosive" or mo.ClassName == "MOSRotating" or (mo.ClassName == "AEmitter" and mo.RootID == moCheck) then
						local distCheck = SceneMan:ShortestDistance(self.MuzzlePos,mo.Pos,SceneMan.SceneWrapsX);
						if (distCheck.Magnitude-mo.Radius) < longDist then
							local toCheckPos = Vector(distCheck.Magnitude*self.negativeNum,0):RadRotate(self.RotAngle);
							local checkPos = self.MuzzlePos + toCheckPos;
							if SceneMan.SceneWrapsX == true then
								if checkPos.X > SceneMan.SceneWidth then
									checkPos = Vector(checkPos.X - SceneMan.SceneWidth,checkPos.Y);
								elseif checkPos.X < 0 then
									checkPos = Vector(SceneMan.SceneWidth + checkPos.X,checkPos.Y);
								end
							end
							local distCheck2 = SceneMan:ShortestDistance(checkPos,mo.Pos,SceneMan.SceneWrapsX);
							if distCheck2.Magnitude-mo.Radius < shortDist and ((distCheck.Magnitude+distCheck2.Magnitude)-(mo.Radius+mo.Radius)) < totalDist then
								if SceneMan:CastStrengthRay(self.MuzzlePos,toCheckPos,0,Vector(0,0),3,0,SceneMan.SceneWrapsX) == false and SceneMan:CastStrengthRay(checkPos,distCheck2:SetMagnitude(distCheck2.Magnitude-mo.Radius),0,Vector(0,0),3,0,SceneMan.SceneWrapsX) == false then
									self.target = mo;
									longDist = distCheck.Magnitude-mo.Radius;
									shortDist = distCheck2.Magnitude-mo.Radius;
									totalDist = ((distCheck.Magnitude+distCheck2.Magnitude)-(mo.Radius+mo.Radius));
								end
							end
						end
					end
				end
			end
		end
	else
		self.target = null;
	end

	if self.target ~= null and self.target.ID ~= 255 then

		local freeSpace = false;
		local lastPlace = Vector();
		if SceneMan:CastStrengthRay(self.MuzzlePos,Vector(35*self.negativeNum,0):RadRotate(self.RotAngle),0,Vector(0,0),3,0,SceneMan.SceneWrapsX) == false then
			local checkPos = self.MuzzlePos + Vector(35*self.negativeNum,0):RadRotate(self.RotAngle);
			for j = 1, 60 do
				if SceneMan.SceneWrapsX == true then
					if checkPos.X > SceneMan.SceneWidth then
						checkPos = Vector(checkPos.X - SceneMan.SceneWidth,checkPos.Y);
					elseif checkPos.X < 0 then
						checkPos = Vector(SceneMan.SceneWidth + checkPos.X,checkPos.Y);
					end
				end
				local moveVel = Vector(20*self.negativeNum,0):RadRotate(self.RotAngle);
				if SceneMan:CastStrengthRay(checkPos,moveVel,0,Vector(0,0),3,0,SceneMan.SceneWrapsX) == false then
					local checkVel = SceneMan:ShortestDistance(checkPos,self.target.Pos,SceneMan.SceneWrapsX);
					checkVel = checkVel:SetMagnitude(checkVel.Magnitude-self.target.Radius);
					if SceneMan:CastStrengthRay(checkPos,checkVel,0,Vector(0,0),3,0,SceneMan.SceneWrapsX) == false then
						freeSpace = true;
						lastPlace = Vector(checkPos.X,checkPos.Y);
						break;
					else
						checkPos = checkPos + moveVel;
					end
				else
					break;
				end
			end
		end

		if freeSpace then

--			FrameMan:DrawLinePrimitive(self.MuzzlePos,lastPlace,13);
--			FrameMan:DrawLinePrimitive(lastPlace,self.target.Pos,13);

--[[
			local freeSpace = false;

			local speed = 70;

			local testVel = Vector(speed*self.negativeNum,0):RadRotate(self.RotAngle);

			local checkPos2 = Vector(lastPlace.X,lastPlace.Y);
			for j = 1, 60 do
				testVel = testVel + Vector((SceneMan.GlobalAcc.X/FrameMan.PPM),(SceneMan.GlobalAcc.Y/FrameMan.PPM));
				local aimVel = Vector(testVel.X,testVel.Y):SetMagnitude(1) + SceneMan:ShortestDistance(checkPos2,self.target.Pos,SceneMan.SceneWrapsX):SetMagnitude(self.adjustmentAmount);
				testVel = Vector(testVel.Magnitude,0):RadRotate(aimVel.AbsRadAngle);
				checkPos2 = checkPos2 + testVel;
				if SceneMan.SceneWrapsX == true then
					if checkPos2.X > SceneMan.SceneWidth then
						checkPos2 = Vector(checkPos2.X - SceneMan.SceneWidth,checkPos2.Y);
					elseif checkPos2.X < 0 then
						checkPos2 = Vector(SceneMan.SceneWidth + checkPos2.X,checkPos2.Y);
					end
				end
				if SceneMan:ShortestDistance(checkPos2,self.target.Pos,SceneMan.SceneWrapsX).Magnitude < 70 then
					FrameMan:DrawLinePrimitive(checkPos2,self.target.Pos,13);
					FrameMan:DrawLinePrimitive(lastPlace,checkPos2,13);
					break;
				end
				FrameMan:DrawLinePrimitive(lastPlace,checkPos2,13);
				lastPlace = Vector(checkPos2.X,checkPos2.Y);
			end
--]]
		end

		local cornerPos = Vector(self.target.Pos.X-self.target.Radius,self.target.Pos.Y-self.target.Radius);
		FrameMan:DrawLinePrimitive(cornerPos,cornerPos+Vector(5,0),13);
		FrameMan:DrawLinePrimitive(cornerPos,cornerPos+Vector(0,5),13);

		cornerPos = Vector(self.target.Pos.X-self.target.Radius,self.target.Pos.Y+self.target.Radius);
		FrameMan:DrawLinePrimitive(cornerPos,cornerPos+Vector(5,0),13);
		FrameMan:DrawLinePrimitive(cornerPos,cornerPos+Vector(0,-5),13);

		cornerPos = Vector(self.target.Pos.X+self.target.Radius,self.target.Pos.Y+self.target.Radius);
		FrameMan:DrawLinePrimitive(cornerPos,cornerPos+Vector(-5,0),13);
		FrameMan:DrawLinePrimitive(cornerPos,cornerPos+Vector(0,-5),13);

		cornerPos = Vector(self.target.Pos.X+self.target.Radius,self.target.Pos.Y-self.target.Radius);
		FrameMan:DrawLinePrimitive(cornerPos,cornerPos+Vector(-5,0),13);
		FrameMan:DrawLinePrimitive(cornerPos,cornerPos+Vector(0,5),13);

		cornerPos = Vector(self.target.Pos.X,self.target.Pos.Y-self.target.Radius);
		FrameMan:DrawLinePrimitive(cornerPos,cornerPos+Vector(0,-5),13);

		cornerPos = Vector(self.target.Pos.X-self.target.Radius,self.target.Pos.Y);
		FrameMan:DrawLinePrimitive(cornerPos,cornerPos+Vector(-5,0),13);

		cornerPos = Vector(self.target.Pos.X,self.target.Pos.Y+self.target.Radius);
		FrameMan:DrawLinePrimitive(cornerPos,cornerPos+Vector(0,5),13);

		cornerPos = Vector(self.target.Pos.X+self.target.Radius,self.target.Pos.Y);
		FrameMan:DrawLinePrimitive(cornerPos,cornerPos+Vector(5,0),13);

	else
		self.target = null;
	end

	if self.Magazine ~= nil then
		if self.reloaded == false then
			self.reloaded = true;
			self.ammoCounter = self.Magazine.RoundCount;
		else
			if self.ammoCounter ~= self.Magazine.RoundCount then
				local bullet = CreateMOPixel("Bullet Dov Smart Pistol");
				bullet.Pos = self.MuzzlePos;
				bullet.Vel = Vector(self.Vel.X,self.Vel.Y) + Vector(70*self.negativeNum,0):RadRotate(self.RotAngle)
				bullet.Team = self.Team;
				bullet.IgnoresTeamHits = true;
				bullet.PresetName = "Bullet Dov Smart Pistol "..self.trackerID;

				local target = null;
				local longDist = 800;
				local shortDist = 98;

				if self.Sharpness == 1 or self.target == null or self.target.ID == 255 then
					for i = 1, MovableMan:GetMOIDCount()-1 do
						local mo = MovableMan:GetMOFromID(i);
						if mo.Team ~= self.Team or ((mo.ClassName == "TDExplosive" or mo.ClassName == "MOSRotating" or mo.ClassName == "AEmitter") and mo.RootID == moCheck) then
							local distCheck = SceneMan:ShortestDistance(self.MuzzlePos,mo.Pos,SceneMan.SceneWrapsX);
							if distCheck.Magnitude-mo.Radius < longDist then
								local toCheckPos = Vector(distCheck.Magnitude*self.negativeNum,0):RadRotate(self.RotAngle);
								local checkPos = self.MuzzlePos + toCheckPos;
								if SceneMan.SceneWrapsX == true then
									if checkPos.X > SceneMan.SceneWidth then
										checkPos = Vector(checkPos.X - SceneMan.SceneWidth,checkPos.Y);
									elseif checkPos.X < 0 then
										checkPos = Vector(SceneMan.SceneWidth + checkPos.X,checkPos.Y);
									end
								end
								local distCheck2 = SceneMan:ShortestDistance(checkPos,mo.Pos,SceneMan.SceneWrapsX);
								if distCheck2.Magnitude-mo.Radius < shortDist then
									if SceneMan:CastStrengthRay(self.MuzzlePos,toCheckPos,0,Vector(0,0),3,0,SceneMan.SceneWrapsX) == false and SceneMan:CastStrengthRay(checkPos,distCheck2:SetMagnitude(distCheck2.Magnitude-mo.Radius),0,Vector(0,0),3,0,SceneMan.SceneWrapsX) == false then
										target = mo;
										longDist = distCheck.Magnitude-mo.Radius;
										shortDist = distCheck2.Magnitude-mo.Radius;
									end
								end
							end
						end
					end
				else
					target = self.target;
				end

				if target ~= null then
					if target.Team == self.Team then
						bullet:SetWhichMOToNotHit(MovableMan:GetMOFromID(self.RootID),-1);
						bullet.Team = -2;
					end
					local tableSlot = #self.bulletTable+1
					self.bulletTable[tableSlot] = bullet;
					self.targetTable[tableSlot] = target;
				end
				MovableMan:AddParticle(bullet);
			end
			self.ammoCounter = self.Magazine.RoundCount;
		end
	else
		self.reloaded = false;
	end

	for i = 1, #self.bulletTable do
		if MovableMan:IsParticle(self.bulletTable[i]) and self.bulletTable[i].PresetName == "Bullet Dov Smart Pistol "..self.trackerID then
			if self.targetTable[i] ~= null and self.targetTable[i].ID ~= 255 then
				if self.bulletTable[i].Age > 25 then
					local checkVel = SceneMan:ShortestDistance(self.bulletTable[i].Pos,self.targetTable[i].Pos,SceneMan.SceneWrapsX);
					checkVel = checkVel:SetMagnitude(checkVel.Magnitude-self.targetTable[i].Radius);
					if SceneMan:CastStrengthRay(self.bulletTable[i].Pos,checkVel,0,Vector(0,0),3,0,SceneMan.SceneWrapsX) == false then
						local aimVel = Vector(self.bulletTable[i].Vel.X,self.bulletTable[i].Vel.Y):SetMagnitude(1) + SceneMan:ShortestDistance(self.bulletTable[i].Pos,self.targetTable[i].Pos,SceneMan.SceneWrapsX):SetMagnitude(self.adjustmentAmount*self.turnTimer.ElapsedSimTimeMS);
						self.bulletTable[i].Vel = Vector(self.bulletTable[i].Vel.Magnitude,0):RadRotate(aimVel.AbsRadAngle);
					end
				end
			else
				self.bulletTable[i] = null;
				self.targetTable[i] = null;
			end
		else
			self.bulletTable[i] = null;
			self.targetTable[i] = null;
		end
	end

	self.turnTimer:Reset();

end