function Create(self)
	self.actionmode = 0; -- 0 is nothing, 1 is draw
	self.cantogglemode = true;
	self.displaymenu = false;
	self.currentmode = 1;
	self.parentplayer = 0;
	self.mapwrapx = SceneMan.SceneWrapsX;
	self.prevposition = Vector(0,0);

	self.modename = {};
	self.modedescription = {};

------------------------------
----- Menu Stuff

	self.modename[1] = "Telekinesis";
	self.modedescription[1] = "Click and drag to pull objects.";

	self.modename[2] = "Teleportation";
	self.modedescription[2] = "Click to teleport you to the cursor.";

	self.modename[3] = " Gun Controller";
	self.modedescription[3] = "Click a gun to select it and press FIRE to use it. Aim by holding CROUCH and moving the cursor. Drop it with JUMP.";
	self.canfire = true;

	self.modename[4] = "Mind Controller";
	self.modedescription[4] = "Click an actor to control it.";

------------------------------

	self.totalmodes = #self.modename;

	local curdist = 10;
	for i = 1,MovableMan:GetMOIDCount()-1 do
		local gun = MovableMan:GetMOFromID(i);
		if gun.PresetName == "D-Telekinesis Rock" and gun.ClassName == "HDFirearm" and (ToHDFirearm(gun).MuzzlePos-self.Pos).Magnitude < curdist then
			actor = MovableMan:GetMOFromID(gun.RootID);
			if MovableMan:IsActor(actor) and ToActor(actor):IsPlayerControlled() == true then
				self.parent = ToActor(actor);
				self.parentgun = ToHDFirearm(gun);
				self.cursor = CreateActor("Dovuken Cursor");
				self.cursor.Pos = self.Pos;
				self.cursor.Team = self.parent.Team;
				MovableMan:AddActor(self.cursor);
				self.parentplayer = self.parent:GetController().Player;
				ActivityMan:GetActivity():SwitchToActor(self.cursor,self.parent:GetController().Player,self.parent.Team);
				self.parent:SetControllerMode(Controller.CIM_DISABLED, -1);
			end
		end
	end

end

function Update(self)
	if MovableMan:IsActor(self.parent) and MovableMan:IsActor(self.cursor) and self.parentgun ~= nil and self.parentgun.ID ~= 255 then
		self.ToDelete = false;
		self.ToSettle = false;
		self.Pos = self.parent.Pos;
		self.cursor.ToDelete = false;
		if self.cursor:GetController():IsState(Controller.BODY_JUMP) and not(self.cursor:GetController():IsState(Controller.WEAPON_FIRE)) then
			self.displaymenu = true;
			if self.cantogglemode == true and self.cursor:GetController():IsState(Controller.HOLD_LEFT) and self.currentmode > 1 then
				self.currentmode = self.currentmode - 1;
				self.cantogglemode = false;
			end
			if self.cantogglemode == true and self.cursor:GetController():IsState(Controller.HOLD_RIGHT) and self.currentmode < self.totalmodes then
				self.currentmode = self.currentmode + 1;
				self.cantogglemode = false;
			end
			if not(self.cursor:GetController():IsState(Controller.HOLD_LEFT)) and not(self.cursor:GetController():IsState(Controller.HOLD_RIGHT)) then
				self.cantogglemode = true;
			end
		else
			self.displaymenu = false;
			if self.cursor:GetController():IsState(Controller.WEAPON_FIRE) then
				self.actionmode = self.currentmode;
			elseif not(self.cursor:GetController():IsState(Controller.WEAPON_FIRE)) then
				self.actionmode = 0;
			end
		end
		if self.cursor:GetController():IsState(Controller.PIE_MENU_ACTIVE) then
			ActivityMan:GetActivity():SwitchToActor(self.parent,self.parentplayer,self.parent.Team);
		end
		if self.cursor:IsPlayerControlled() == false then
			self.cursor.ToDelete = true;
			self.cursor.LifeTime = 0;
		end

----------------------------------------
	if self.actionmode == 1 then -- Telekinesis
----------------------------------------

		if self.veltarget == nil then
			local detectobject = SceneMan:GetMOIDPixel(self.cursor.Pos.X,self.cursor.Pos.Y);
			if detectobject ~= 255 then
				local tempobject = MovableMan:GetMOFromID(detectobject);
				self.veltarget = MovableMan:GetMOFromID(tempobject.RootID);
			end
		elseif self.veltarget ~= nil then
			if self.veltarget.ID ~= 255 then
				self.veltarget.Vel = SceneMan:ShortestDistance(self.veltarget.Pos,self.cursor.Pos,self.mapwrapx);
			else
				self.veltarget = nil;
			end
		end

----------------------------------------
	elseif self.actionmode == 2 then -- Teleportation
----------------------------------------

		if self.cursor:GetController():IsState(Controller.WEAPON_FIRE) and self.canfire == true then
			self.canfire = false;
			self.parent.Pos = self.cursor.Pos;
			self.parent.Vel = Vector(0,0);
			self.parent:FlashWhite(1500);
			local fxa = CreateAEmitter("Teleporter Effect A");
			fxa.Pos = self.parent.Pos;
			MovableMan:AddParticle(fxa);
		end

----------------------------------------
	elseif self.actionmode == 3 then -- Gun Controller
----------------------------------------

		if self.guntarget == nil then
			local detectobject = SceneMan:GetMOIDPixel(self.cursor.Pos.X,self.cursor.Pos.Y);
			if detectobject ~= 255 then
				local temptarget = MovableMan:GetMOFromID(detectobject);
				local tempguntarget = MovableMan:GetMOFromID(temptarget.RootID);
				if MovableMan:IsDevice(tempguntarget) and tempguntarget.ClassName == "HDFirearm" then
					self.guntarget = ToHDFirearm(tempguntarget);
					self.canfire = false;
				end
			end
			elseif self.guntarget ~= nil then
			if self.guntarget.ID ~= 255 then
				if not(self.cursor:GetController():IsState(Controller.BODY_CROUCH)) then
					self.guntarget.Pos = self.cursor.Pos;
					self.guntarget.PinStrength = 0;
				elseif self.cursor:GetController():IsState(Controller.BODY_CROUCH) then
					self.guntarget.PinStrength = 99999;
					self.guntarget.RotAngle = SceneMan:ShortestDistance(self.guntarget.Pos,self.cursor.Pos,self.mapwrapx).AbsRadAngle;
				end
					self.guntarget.AngularVel = 0;
					self.guntarget.Vel = Vector(0,0);
					self.guntarget.HFlipped = false;
				if self.cursor:GetController():IsState(Controller.WEAPON_FIRE) then
					if self.canfire == true then
						self.guntarget:Activate();
					end
				end
			elseif self.guntarget.ID == 255 then
				self.guntarget = nil;
			end
		end

----------------------------------------
	elseif self.actionmode == 4 then -- Mind Controller
----------------------------------------

	local detectobject = SceneMan:GetMOIDPixel(self.cursor.Pos.X,self.cursor.Pos.Y);
		if detectobject ~= 255 then
			local temptarget = MovableMan:GetMOFromID(detectobject);
			self.controltarget = MovableMan:GetMOFromID(temptarget.RootID);
			if MovableMan:IsActor(self.controltarget) then
				ActivityMan:GetActivity():SwitchToActor(ToActor(self.controltarget),self.parentplayer,ToActor(self.controltarget).Team);
			end
			self.controltarget = nil;
		end

----------------------------------------
	elseif self.actionmode == 0 then -- Use this to reset variables
----------------------------------------

	self.veltarget = nil;

	self.canfire = true;

		if self.currentmode == 3 then 
			if self.cursor:GetController():IsState(Controller.BODY_JUMP) then
				self.guntarget = nil;
			end
			if self.guntarget ~= nil then
				if self.guntarget.ID ~= 255 then
					if not(self.cursor:GetController():IsState(Controller.BODY_CROUCH)) then
						self.guntarget.Pos = self.cursor.Pos;
						self.guntarget.PinStrength = 0;
					elseif self.cursor:GetController():IsState(Controller.BODY_CROUCH) then
						self.guntarget.PinStrength = 99999;
						self.guntarget.RotAngle = SceneMan:ShortestDistance(self.guntarget.Pos,self.cursor.Pos,self.mapwrapx).AbsRadAngle;
					end
					self.guntarget.Vel = Vector(0,0);
					self.guntarget.AngularVel = 0;
					if not(self.cursor:GetController():IsState(Controller.WEAPON_FIRE)) then
						self.canfire = true;
						self.guntarget:Deactivate();
					end
				end
			end
		end

----------------------------------------
	end
----------------------------------------
	else
		self.cursor.ToDelete = true;
		self.cursor.LifeTime = 0;
		self.ToDelete = true;
		self.LifeTime = 0;
	end

	if self.displaymenu == false then
		local textsetter = self.modename[self.currentmode].." - "..self.modedescription[self.currentmode];
		FrameMan:ClearScreenText(self.parentplayer);
		FrameMan:SetScreenText(textsetter,self.parentplayer,0,1,false);
	elseif self.displaymenu == true then
		local textsetter = "Powers: "..self.modename[self.currentmode].." ("..self.currentmode.."/"..self.totalmodes..")";
		FrameMan:ClearScreenText(self.parentplayer);
		FrameMan:SetScreenText(textsetter,self.parentplayer,0,1,true);
	end

end