function Create(self)

	self.mapwrapx = SceneMan.SceneWrapsX;

----------------------------------------
----- Settings



----------------------------------------

	local curdist = 10;
	for i = 1, MovableMan:GetMOIDCount()-1 do
		self.gun = MovableMan:GetMOFromID(i);
		if (self.gun.PresetName == "Dov Translocator" or self.gun.PresetName == "Dov Translocator (Speed)") and self.gun.ClassName == "HDFirearm" and SceneMan:ShortestDistance(self.Pos,ToHDFirearm(self.gun).MuzzlePos,self.mapwrapx).Magnitude < curdist then
			self.parentgun = ToHDFirearm(self.gun);
			if self.parentgun.Sharpness == 0 or self.parentgun.Sharpness == 4 then
				if self.parentgun.Sharpness == 0 then
					self.parentgun.Sharpness = 1;
				end
				local flipNum = 1;
				if self.parentgun.HFlipped == true then
					flipNum = -1;
				end
				self.Vel = self.parentgun.Vel + Vector(30*flipNum,0):RadRotate(self.parentgun.RotAngle);
				self.RotAngle = self.Vel.AbsRadAngle;
				local soundfx = CreateAEmitter("Dovuken Translocator Sound Fire");
				soundfx.Pos = self.parentgun.MuzzlePos;
				MovableMan:AddParticle(soundfx);
			else
				self.parentgun.Sharpness = 0;
				self.parentgun = nil;
				self.ToDelete = true;
			end
			break;
		end
	end

end

function Update(self)

	if self.parentgun ~= nil and self.parentgun.ID ~= 255 then
		self.ToDelete = false;
		self.ToSettle = false;
		self:NotResting();
		self.Health = 100;

		if MovableMan:IsParticle(self.beaconGlow) then
			if self.beaconGlow.PresetName == "Particle Dovuken Translocator Beacon Glow" then
				self.beaconGlow.ToDelete = false;
				self.beaconGlow.ToSettle = false;
				self.beaconGlow.Pos = self.Pos;
			else
				self.beaconGlow = nil;
			end
		else
			self.beaconGlow = CreateMOPixel("Particle Dovuken Translocator Beacon Glow");
			self.beaconGlow.Pos = self.Pos;
			self.beaconGlow.ToDelete = false;
			self.beaconGlow.ToSettle = false;
			MovableMan:AddParticle(self.beaconGlow);
		end

		self.parent = nil;
		self.actor = MovableMan:GetMOFromID(self.parentgun.RootID);

		if MovableMan:IsActor(self.actor) == true then
			self.parent = ToActor(self.actor);
		end

		if MovableMan:IsActor(self.camera) then
			self.camera.ToDelete = false;
			self.camera.ToSettle = false;
			self.camera.Pos = self.Pos;
			if self.camera:IsPlayerControlled() then
				if self.camera:GetController():IsState(Controller.WEAPON_FIRE) then
					self.camera.Sharpness = 0;
				end
				self.parentgun.Sharpness = self.camera.Sharpness;
				if self.camera.Sharpness ~= 1 then
					if self.camera.Sharpness == 3 then
						self.parentgun.Sharpness = 1;
					end
					if MovableMan:IsActor(self.parent) then
						ActivityMan:GetActivity():SwitchToActor(self.parent,self.camera:GetController().Player,self.parent.Team);
					end
					self.camera.ToDelete = true;
				end
			else
				self.camera.ToDelete = true;
			end
		end

		if self.parentgun.Sharpness == 0 then
			local soundfx = CreateAEmitter("Dovuken Translocator Sound Delete");
			soundfx.Pos = self.parentgun.MuzzlePos;
			MovableMan:AddParticle(soundfx);
			self.ToDelete = true;
		end

		if self.parentgun.Sharpness == 3 and MovableMan:IsActor(self.parent) and self.parent:IsPlayerControlled() and MovableMan:IsActor(self.camera) == false then
			self.parentgun.Sharpness = 1;
			self.camera = CreateActor("Dovuken Translocator Remote Control");
			self.camera.Pos = self.Pos;
			self.camera.Team = -1;
			MovableMan:AddActor(self.camera);
			ActivityMan:GetActivity():SwitchToActor(self.camera,self.parent:GetController().Player,-1);
		end

		if self.parentgun.Sharpness == 4 then
			if self.parentgun:IsActivated() == false then
				self.parentgun.Sharpness = 5;
			end
		end

		if self.parentgun.Sharpness == 2 or self.parentgun.Sharpness == 5 then
			if self.parentgun.Sharpness == 2 then
				self.parentgun.Sharpness = 0;
			else
				self.parentgun.Sharpness = 4;
			end
			if MovableMan:IsActor(self.parent) then

				for i = 1,MovableMan:GetMOIDCount()-1 do
					bodypart = MovableMan:GetMOFromID(i);
					if bodypart.RootID == self.parent.ID then
						local teleghost = CreateMOPixel("Particle Dovuken Translocator Teleport Regenerate");
						teleghost.Pos = self.Pos + (bodypart.Pos-self.parent.Pos):RadRotate(self.parent.RotAngle);
						if math.random(0,1) == 0 then
							teleghost.Vel = Vector(8,0);
						elseif math.random(0,1) == 1 then
							teleghost.Vel = Vector(-8,0);
						end
						MovableMan:AddParticle(teleghost);
					end
				end

				self.parent:FlashWhite(500);

			end
			self.actor.Pos = self.Pos;
			self.actor.Vel = Vector(0,0);
			local soundfx = CreateAEmitter("Dovuken Translocator Sound Teleport");
			soundfx.Pos = self.Pos;
			MovableMan:AddParticle(soundfx);

			self.ToDelete = true;
		end

	else
		self.ToDelete = true;
	end

	self.lastpos = self.Pos;

end

function Destroy(self)

	if MovableMan:IsActor(self.camera) then
		self.camera.ToDelete = true;
	end

	if MovableMan:IsParticle(self.beaconGlow) then
		self.beaconGlow.ToDelete = true;
	end

end