function VEBLWrapPos(checkPos)
	if SceneMan.SceneWrapsX == true then
		if checkPos.X > SceneMan.SceneWidth then
			checkPos = Vector(checkPos.X - SceneMan.SceneWidth,checkPos.Y);
		elseif checkPos.X < 0 then
			checkPos = Vector(SceneMan.SceneWidth + checkPos.X,checkPos.Y);
		end
	end
	return checkPos;
end

function Create(self)

	self.lifeTimer = Timer();
	self.hasexplosive = false;
	self.stuck = 0;

	self.linelength = 6;

	for i = 1,MovableMan:GetMOIDCount()-1 do
		local gun = MovableMan:GetMOFromID(i);
		if gun.PresetName == "VE Bolt Launcher" and SceneMan:ShortestDistance(self.Pos,ToHDFirearm(gun).MuzzlePos,SceneMan.SceneWrapsX).Magnitude < 10 then
			local actor = MovableMan:GetMOFromID(gun.RootID);
			if MovableMan:IsActor(actor) then
				self.Vel = actor.Vel + Vector(60,0):RadRotate(ToActor(actor):GetAimAngle(true));
				local item = ToActor(actor):Inventory();
				if item ~= nil and item.ClassName == "TDExplosive" then
					self.Sharpness = gun.Sharpness;
					self.explosive = CreateTDExplosive(item.PresetName);
					self.explosive.Pos = self.Pos;
					self.explosive.Team = self.Team;
					self.explosive.Sharpness = item.Sharpness;
					self.explosive:Activate();
					MovableMan:AddParticle(self.explosive);
					self.hasexplosive = true;
					self.linelength = self.linelength + (self.explosive.Radius*0.5);
				end
				break;
			end
		end
	end

end

function Update(self)

	self.ToDelete = false;

	if self.hasexplosive then
		if MovableMan:IsDevice(self.explosive) then

			local connectpos = VEBLWrapPos(self.Pos+Vector(-5,0):RadRotate(self.RotAngle));

			local dist = SceneMan:ShortestDistance(self.explosive.Pos,connectpos,SceneMan.SceneWrapsX);
			local distm = dist.Magnitude;

			if distm > self.linelength then

				self.explosive.Pos = VEBLWrapPos(connectpos + (dist*-1):SetMagnitude(self.linelength));

				local pullamountnumber = math.abs(dist.AbsRadAngle-self.explosive.Vel.AbsRadAngle)/(math.pi*2);
				self.explosive.Vel = self.explosive.Vel + dist:SetMagnitude(self.explosive.Vel.Magnitude*pullamountnumber);

			end

			FrameMan:DrawLinePrimitive(connectpos,self.explosive.Pos,250);

		else
			self.ToDelete = true;
		end
	else
		if self.lifeTimer:IsPastSimMS(3000) then
			self.ToDelete = true;
		end
	end

	if self.stuck == 0 then

		self.raylength = self.Vel.Magnitude;
		self.dots = math.floor(self.raylength);

		for i = 1, self.dots do
			local checkPos = VEBLWrapPos(self.Pos + Vector(self.Vel.X,self.Vel.Y):SetMagnitude((i/self.dots)*self.raylength));
			local terrCheck = SceneMan:GetTerrMatter(checkPos.X,checkPos.Y);
			if terrCheck == 0 then
				local moCheck = SceneMan:GetMOIDPixel(checkPos.X,checkPos.Y);
				if moCheck ~= 255 then
					local mo = MovableMan:GetMOFromID(moCheck);
					if mo.Team ~= self.Team then
						self.Pos = checkPos;
						self.PinStrength = 1000;
						self.stuck = 2;
						self.target = mo;
						self.stickpos = SceneMan:ShortestDistance(self.target.Pos,self.Pos,SceneMan.SceneWrapsX);
						self.stickdirection = self.target.RotAngle;
						self.stickrotation = self.RotAngle;
						break;
					end
				end
			else
				self.Pos = checkPos;
				self.PinStrength = 1000;
				self.stuck = 1;
				break;
			end
		end

	else

		if self.stuck == 2 then
			if self.target ~= nil and self.target.ID ~= 255 then
				self.Pos = self.target.Pos + Vector(self.stickpos.X,self.stickpos.Y):RadRotate(self.target.RotAngle-self.stickdirection);
				self.RotAngle = self.stickrotation+(self.target.RotAngle-self.stickdirection);
			else
				self.stuck = 0;
			end
		end
	end

end