function Create(self)

	self.moveTimer = Timer();
	self.targettimer = Timer();

	self.turnsharpness = 16;
	self.detectrange = 600;

	self.raylength = 10;
	self.rayPixSpace = 2;

	self.dots = math.floor(self.raylength/self.rayPixSpace);

	for i = 1,MovableMan:GetMOIDCount()-1 do
		local gun = MovableMan:GetMOFromID(i);
		if gun.PresetName == "VE Missile Launcher" and SceneMan:ShortestDistance(self.Pos,ToHDFirearm(gun).MuzzlePos,SceneMan.SceneWrapsX).Magnitude < 10 then
			local actor = MovableMan:GetMOFromID(gun.RootID);
			if MovableMan:IsActor(actor) then
				local item = ToActor(actor):Inventory();
				if item ~= nil and item.ClassName == "TDExplosive" then
					self.Sharpness = gun.Sharpness;
					self.explosive = CreateTDExplosive(item.PresetName);
					self.explosive.Pos = self.Pos + Vector((self.explosive.Radius*0.5)+(self.Radius*0.5),0):RadRotate(self.RotAngle);
					self.explosive.Team = self.Team;
					self.Vel = actor.Vel + Vector(30,0):RadRotate(ToActor(actor):GetAimAngle(true));
					self.explosive.Vel = Vector(self.Vel.X,self.Vel.Y);
					self.explosive.RotAngle = self.RotAngle;
					self.explosive.Sharpness = item.Sharpness;
					self.explosive:Activate();
					MovableMan:AddParticle(self.explosive);
					if self.Sharpness == 0 then
						self.ToDelete = true;
					end
				else
					self.ToDelete = true;
				end
				break;
			end
		end
	end

end

function Update(self)

	if MovableMan:IsDevice(self.explosive) then

		self.explosive.Pos = self.Pos + Vector((self.explosive.Radius*0.5)+(self.Radius*0.5),0):RadRotate(self.RotAngle);
		self.explosive.Vel = Vector(self.Vel.X,self.Vel.Y);
		self.explosive.RotAngle = self.RotAngle;
		self.explosive.AngularVel = 0;

		if self.Sharpness == 1 or self.Sharpness == 2 then

			self.ToDelete = false;

			self.raylength = self.Vel.Magnitude;
			self.dots = math.floor(self.raylength/self.rayPixSpace);

			for i = 1, self.dots do
				local checkPos = self.Pos + Vector(self.Vel.X,self.Vel.Y):SetMagnitude((i/self.dots)*self.raylength);
				if SceneMan.SceneWrapsX == true then
					if checkPos.X > SceneMan.SceneWidth then
						checkPos = Vector(checkPos.X - SceneMan.SceneWidth,checkPos.Y);
					elseif checkPos.X < 0 then
						checkPos = Vector(SceneMan.SceneWidth + checkPos.X,checkPos.Y);
					end
				end
				local terrCheck = SceneMan:GetTerrMatter(checkPos.X,checkPos.Y);
				if terrCheck == 0 then
					local moCheck = SceneMan:GetMOIDPixel(checkPos.X,checkPos.Y);
					if moCheck ~= 255 then
						local actor = MovableMan:GetMOFromID( MovableMan:GetMOFromID(moCheck).RootID );
						if actor.Team ~= self.Team then
							if self.Sharpness == 1 then
								self.explosive.Vel = Vector(0,0);
							else
								self.explosive:GibThis();
							end
							self.ToDelete = true;
						end
					end
				else
					if self.Sharpness == 1 then
						self.explosive.Vel = Vector(0,0);
					else
						self.explosive:GibThis();
					end
					self.ToDelete = true;
				end
			end

			local movePercent = self.moveTimer.ElapsedSimTimeMS/1000;
			self.moveTimer:Reset();

			if MovableMan:IsActor(self.target) then

				local aimVector = SceneMan:ShortestDistance(self.Pos,self.target.Pos+Vector(0,(-0.5)*self.target.Radius),SceneMan.SceneWrapsX);
				self.RotAngle = (Vector(1,0):RadRotate(self.RotAngle) + Vector(self.turnsharpness*movePercent,0):RadRotate(aimVector.AbsRadAngle)).AbsRadAngle;

			elseif not(MovableMan:IsActor(self.target)) and self.targettimer:IsPastSimMS(250) then
				self.targettimer:Reset();

				for actor in MovableMan.Actors do
					if actor.Team ~= self.Team then
						self.potentialtargetdist = SceneMan:ShortestDistance(self.Pos,actor.Pos,SceneMan.SceneWrapsX);
						self.terrcheck = Vector(0,0);
						if (self.lastdist == nil or (self.lastdist ~= nil and self.potentialtargetdist.Magnitude < self.lastdist)) and self.potentialtargetdist.Magnitude <= self.detectrange and SceneMan:CastStrengthRay(self.Pos,self.potentialtargetdist:SetMagnitude(self.potentialtargetdist.Magnitude-actor.Radius),0,self.terrcheck,5,0,SceneMan.SceneWrapsX) == false then
							self.lastdist = self.potentialtargetdist.Magnitude;
							self.target = actor;
							self.lasttargetpos = Vector(self.target.Pos.X,self.target.Pos.Y);
						end
					end
				end

			end
		end

	else
		self.ToDelete = true;
	end

end